<?xml version="1.0" encoding="UTF-8"?>
<!--
1.6 WBISRVR/ws/code/bsm.tools/eclipse/plugins/com.ibm.wbis.statemachine.deployment/src/com/ibm/wbis/statemachine/deployment/xsl/mapping.sacl2bpel.xsl, WAS.adaptive.entity, WBIX.WBISRVR 12/12/05 15:57:42
     
IBM Confidential
OCO Source Materials
5724-L01, 5655-N53, 5724-I82, 5655-R15
(C) Copyright IBM Corporation 2005, 2009
The source code for this program is not published or otherwise
divested of its trade secrets, irrespective of what has been
deposited with the U.S. Copyright Office.
     
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns="http://schemas.xmlsoap.org/ws/2004/03/business-process/"
    xmlns:wpc="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"
    xmlns:wsdl="http://www.ibm.com/xmlns/prod/websphere/scdl/wsdl/v6.0.0/"
    xmlns:sacl="http://www.ibm.com/xmlns/prod/websphere/wbi/sacl/6.0.0"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:xalan="http://xml.apache.org/xalan"
    xmlns:genutil="http://xml.apache.org/xalan/java/com.ibm.wbis.statemachine.deployment.translator.BSMXSLHelper"
    extension-element-prefixes="genutil"
    xmlns:bpeltranslator="javaext/com.ibm.wbis.statemachine.deployment.translator.BPELTranslator"
    xmlns:deploymentpkg="javaext/com.ibm.wbis.statemachine.deployment.translator">

    <xsl:output method="xml" indent="yes"/>

	<xsl:key name="events" match="sacl:operation" use="concat(@portType, concat('.', @name))"/>
	<xsl:key name="trans" match="sacl:transition" use="concat(sacl:operation/@portType, concat('.', sacl:operation/@name))"/>
	<xsl:key name="compositeState" match="sacl:compositeState" use="@name"/>
	<xsl:key name="simpleState" match="sacl:state" use="@name"/>
	
	<!-- debug id generator -->
	<xsl:variable name="bpeltranslator" select="bpeltranslator:getBPELTranslator()"/>
	<xsl:variable name="bsmxslhelper" select="deploymentpkg:getBSMXSLHelper($bpeltranslator)"/>
	
	<xsl:template match="/">
	<xsl:variable name="nl"><xsl:text>
	</xsl:text></xsl:variable>
		<xsl:variable name="stateMachineName">
			<xsl:value-of select="*/@name"/>	
		</xsl:variable>	
		
		<xsl:variable name="stateMachineTargetNamespace">
			<xsl:value-of select="*/@targetNamespace"/>	
		</xsl:variable>	

        <genutil:trace message="=============== S T A T E   M A C H I N E   (" select="concat($stateMachineName, ')   ==============')"/>

		<!-- Process header -->
		<process targetNamespace="{$stateMachineTargetNamespace}">		
			<xsl:attribute name="name">
				<xsl:value-of select="$stateMachineName"/>
			</xsl:attribute>
			<xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
			<xsl:attribute name="suppressJoinFailure">no</xsl:attribute>
            <xsl:attribute name="ignoreMissingData" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">yes</xsl:attribute>

			<xsl:if test="sacl:stateMachineDefinition/@validFrom">
				<xsl:attribute name="validFrom" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="sacl:stateMachineDefinition/@validFrom"/></xsl:attribute>
			</xsl:if>

			<xsl:if test="sacl:stateMachineDefinition/@autoDelete">
				<xsl:attribute name="autoDelete" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="sacl:stateMachineDefinition/@autoDelete"/></xsl:attribute>
			</xsl:if>
			
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
				<xsl:attribute name="name">generatedBy</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:text>BusinessStateMachine</xsl:text>
				</xsl:element>
			</xsl:element>
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
				<xsl:attribute name="name">name</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:value-of select="sacl:stateMachineDefinition/@name"/>
				</xsl:element>
			</xsl:element>			
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">			
				<xsl:attribute name="name">targetNameSpace</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:value-of select="$stateMachineTargetNamespace"/>
				</xsl:element>
			</xsl:element>			
			<xsl:if test="sacl:stateMachineDefinition/@validFrom">
				<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:attribute name="name">validFrom</xsl:attribute>
					<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
						<xsl:value-of select="sacl:stateMachineDefinition/@validFrom"/>
					</xsl:element>
				</xsl:element>
			</xsl:if>
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">			
				<xsl:attribute name="name">generatorVersion</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:value-of select="deploymentpkg:get-plugin-version($bsmxslhelper)"/>
				</xsl:element>
			</xsl:element>
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">			
				<xsl:attribute name="name">buildVersion</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">1 6</xsl:element>
			</xsl:element>
			
			<!-- java globals -->
            <xsl:element name="javaGlobals" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                <xsl:element name="import" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                    <xsl:attribute name="packages">java.util.Hashtable</xsl:attribute>
                </xsl:element>
                <xsl:element name="import" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                    <xsl:attribute name="packages">com.ibm.websphere.sca.ServiceManager</xsl:attribute>
                </xsl:element>
                <xsl:element name="import" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                    <xsl:attribute name="packages">com.ibm.websphere.bo.BOFactory</xsl:attribute>
                </xsl:element>
                <xsl:element name="import" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                    <xsl:attribute name="packages">javax.xml.namespace.QName</xsl:attribute>
                </xsl:element>
                <xsl:for-each select="//sacl:javaGlobals/sacl:import">
                    <xsl:element name="import" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                        <xsl:attribute name="packages"><xsl:value-of select="@packages"/></xsl:attribute>
                    </xsl:element>
                </xsl:for-each>	
            </xsl:element>
			
			<!-- Partner links -->
			<xsl:value-of select="$nl"/><xsl:comment>Partner link definitions</xsl:comment><xsl:value-of select="$nl"/>
			<xsl:element name="partnerLinks">
				<!-- Defined interfaces / references -->
				<xsl:apply-templates select="*/sacl:interfaces/sacl:interface"/>
				<xsl:apply-templates select="*/sacl:references/sacl:reference"/>
			</xsl:element>
			
            <genutil:trace message="======================================== Variable definitions for " select="$stateMachineName"/>

			<xsl:value-of select="$nl"/><xsl:comment>Variable definitions</xsl:comment><xsl:value-of select="$nl"/>
			<xsl:element name="variables">

				<xsl:element name="variable">
				   		<xsl:attribute name="name">BSMState_Input_</xsl:attribute>
                        <xsl:attribute name="type">artifacts:runtimeStateType</xsl:attribute>
                        <xsl:element name="wpc:queryProperties">
                            <xsl:element name="wpc:queryProperty">
                                <xsl:attribute name="name">name</xsl:attribute>
                                <xsl:attribute name="type">xsd:string</xsl:attribute>
                                <xsl:element name="wpc:query">/DisplayState</xsl:element>				
                            </xsl:element>				
			            </xsl:element>				
				</xsl:element>		

				<xsl:element name="variable">
				   		<xsl:attribute name="name">BSM__Output__Fault</xsl:attribute>
						<xsl:attribute name="type">xsd:string</xsl:attribute>
				</xsl:element>

                <xsl:if test="/*/*/sacl:transition/sacl:guard">	
                    <xsl:element name="variable">
                            <xsl:attribute name="name">GuardValue</xsl:attribute>
                            <xsl:attribute name="type">xsd:boolean</xsl:attribute>
                    </xsl:element>
                </xsl:if>
                <xsl:variable name="initStateName" select="/*/sacl:mainStateMachine/sacl:initialState/@name"/>	
                <xsl:variable name="initTrans" select="/*/sacl:mainStateMachine/sacl:transition[sacl:sourceState = $initStateName]"/>
                <xsl:variable name="initOperationName" select="$initTrans/sacl:operation/@name"/>

				<xsl:apply-templates select="//sacl:transition/sacl:operation" mode="variable">
                    <xsl:with-param name="initialOpName" select="$initOperationName"/>
                </xsl:apply-templates>

				<xsl:apply-templates select="//sacl:variables/sacl:variable" mode="variable"/>

			</xsl:element>

			<!-- Correlation sets -->
			<xsl:value-of select="$nl"/><xsl:comment>Correlation set definitions</xsl:comment><xsl:value-of select="$nl"/>
			<xsl:element name="correlationSets">
				<xsl:for-each select="*/sacl:correlationSet">
					<xsl:element name="correlationSet">
				   		<xsl:attribute name="name">
							<xsl:value-of select="@name"/>
						</xsl:attribute>
						<xsl:attribute name="properties">
							<xsl:variable name="properties"><xsl:value-of select="@properties"/></xsl:variable>
							<xsl:value-of select="deploymentpkg:convert-namespace-prefix-for-properties($bsmxslhelper,$properties)"/>
						</xsl:attribute>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>
	
			<!-- event handlers -->
			<xsl:if test="deploymentpkg:status-query-port-exists($bsmxslhelper) or deploymentpkg:display-status-query-port-exists($bsmxslhelper)">
				<xsl:element name="eventHandlers">
                    <xsl:if test="deploymentpkg:status-query-port-exists($bsmxslhelper)">
                        <xsl:variable name="portType"><xsl:value-of select="deploymentpkg:status-query-port-type($bsmxslhelper)"/></xsl:variable>
                        <xsl:variable name="event">
                            <xsl:value-of select="deploymentpkg:status-query-port-type-qname($bsmxslhelper)"/>
                            <xsl:text>.getState</xsl:text>
                        </xsl:variable>
						<xsl:element name="onEvent">
							<xsl:attribute name="partnerLink"><xsl:value-of select="deploymentpkg:status-query-partner-name($bsmxslhelper)"/></xsl:attribute>
							<xsl:attribute name="portType"><xsl:value-of select="deploymentpkg:status-query-port-type-qname($bsmxslhelper)"/></xsl:attribute>
							<xsl:attribute name="operation">getState</xsl:attribute>
							<xsl:attribute name="variable">getStateRequest</xsl:attribute>
							<xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:input-type($bsmxslhelper,$event)"/></xsl:attribute>
							<xsl:element name="correlations">
								<xsl:element name="correlation">
									<xsl:attribute name="initiate">no</xsl:attribute>
									<xsl:attribute name="set">
										<xsl:value-of select="/*/sacl:correlationSet/@name"/>
									</xsl:attribute>
								</xsl:element>
							</xsl:element>
                            <xsl:element name="scope">
                                <xsl:attribute name="name">GetStateScope</xsl:attribute>
                                <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
                                <xsl:element name="variables">
                                    <xsl:element name="variable">
                                            <xsl:attribute name="name">ActState</xsl:attribute>
                                            <xsl:attribute name="type">xsd:string</xsl:attribute>
                                    </xsl:element>
                                </xsl:element>
                                <xsl:element name="sequence">
                                    <xsl:call-template name="ExecuteJavaCode">
                                        <xsl:with-param name="code">
                                            /**
                                             *@bpe.readOnlyVariables names="BSMState_Input_"
                                             */
                                            if (BSMState_Input_ == null)
                                            {
                                                ActState = "<xsl:value-of select="/sacl:stateMachineDefinition/sacl:mainStateMachine/sacl:initialState/@name"/>";
                                            }                     
                                            else
                                            {
                                                ActState = BSMState_Input_.getString("ActState");
                                            }
                                        </xsl:with-param>
                                    </xsl:call-template>
                                    <xsl:element name="reply">
                                        <xsl:attribute name="partnerLink"><xsl:value-of select="deploymentpkg:status-query-partner-name($bsmxslhelper)"/></xsl:attribute>
                                        <xsl:attribute name="portType"><xsl:value-of select="deploymentpkg:status-query-port-type-qname($bsmxslhelper)"/></xsl:attribute>
                                        <xsl:attribute name="operation">getState</xsl:attribute>
                                        <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                            <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                               <xsl:attribute name="name">state</xsl:attribute>
                                               <xsl:attribute name="variable">ActState</xsl:attribute>
                                           </xsl:element>
                                        </xsl:element>
                                    </xsl:element>							
                                </xsl:element>
                            </xsl:element>
						</xsl:element>
                    </xsl:if>

                    <xsl:if test="deploymentpkg:display-status-query-port-exists($bsmxslhelper)">
                        <xsl:variable name="portType"><xsl:value-of select="deploymentpkg:display-status-query-port-type($bsmxslhelper)"/></xsl:variable>
                        <xsl:variable name="event">
                            <xsl:value-of select="deploymentpkg:display-status-query-port-type-qname($bsmxslhelper)"/>
                            <xsl:text>.getDisplayState</xsl:text>
                        </xsl:variable>
						<xsl:element name="onEvent">
							<xsl:attribute name="partnerLink"><xsl:value-of select="deploymentpkg:display-status-query-partner-name($bsmxslhelper)"/></xsl:attribute>
							<xsl:attribute name="portType"><xsl:value-of select="deploymentpkg:display-status-query-port-type-qname($bsmxslhelper)"/></xsl:attribute>
							<xsl:attribute name="operation">getDisplayState</xsl:attribute>
							<xsl:attribute name="variable">getDisplayStateRequest</xsl:attribute>
							<xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:input-type($bsmxslhelper,$event)"/></xsl:attribute>
							<xsl:element name="correlations">
								<xsl:element name="correlation">
									<xsl:attribute name="initiate">no</xsl:attribute>
									<xsl:attribute name="set">
										<xsl:value-of select="/*/sacl:correlationSet/@name"/>
									</xsl:attribute>
								</xsl:element>
							</xsl:element>
                            <xsl:element name="scope">
                                <xsl:attribute name="name">GetDisplayStateScope</xsl:attribute>
                                <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
                                <xsl:element name="variables">
                                    <xsl:element name="variable">
                                            <xsl:attribute name="name">DisplayState</xsl:attribute>
                                            <xsl:attribute name="type">xsd:string</xsl:attribute>
                                    </xsl:element>
                                </xsl:element>
                                <xsl:element name="sequence">
                                    <xsl:call-template name="ExecuteJavaCode">
                                        <xsl:with-param name="code">
                                            /**
                                             *@bpe.readOnlyVariables names="BSMState_Input_"
                                             */
                                            if (BSMState_Input_ == null)
                                            {
                                                DisplayState = "<xsl:value-of select="/sacl:stateMachineDefinition/sacl:mainStateMachine/sacl:initialState/@displayName"/>";
                                            }                     
                                            else
                                            {
                                                DisplayState = BSMState_Input_.getString("DisplayState");
                                            }
                                        </xsl:with-param>
                                    </xsl:call-template>
                                    <xsl:element name="reply">
                                        <xsl:attribute name="partnerLink"><xsl:value-of select="deploymentpkg:display-status-query-partner-name($bsmxslhelper)"/></xsl:attribute>
                                        <xsl:attribute name="portType"><xsl:value-of select="deploymentpkg:display-status-query-port-type-qname($bsmxslhelper)"/></xsl:attribute>
                                        <xsl:attribute name="operation">getDisplayState</xsl:attribute>
                                        <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                            <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                               <xsl:attribute name="name">state</xsl:attribute>
                                               <xsl:attribute name="variable">DisplayState</xsl:attribute>
                                           </xsl:element>
                                        </xsl:element>
                                    </xsl:element>							
                                </xsl:element>
                            </xsl:element>
						</xsl:element>
                    </xsl:if>
				</xsl:element>
			</xsl:if>

			<!-- Activity -->
			<xsl:value-of select="$nl"/><xsl:comment>Activity definitions</xsl:comment><xsl:value-of select="$nl"/>

			<xsl:element name="sequence">
				<xsl:attribute name="name">MainSequence</xsl:attribute>				
				<xsl:attribute name="wpc:displayName">Type=com.ibm.wbi.SACL6.0 Version=6.0</xsl:attribute>
				<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">0</xsl:attribute>
				<xsl:apply-templates select="*/sacl:mainStateMachine/sacl:initialState" mode="init"/>
			</xsl:element>
		</process>
	</xsl:template>
	
	<xsl:template match="sacl:variable" mode="variable">
		<xsl:element name="variable">
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
            <xsl:choose>
                <xsl:when test="@type">
                    <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
                </xsl:when>
                <xsl:when test="@element">
                    <xsl:attribute name="element"><xsl:value-of select="@element"/></xsl:attribute>
                </xsl:when>
                <xsl:otherwise>
                    <genutil:trace message="unrecognized variable type for variable " select="@name"/>
                </xsl:otherwise>
            </xsl:choose>
		</xsl:element>
	</xsl:template>

	<!-- Add event message variables -->
	<xsl:template match="sacl:operation" mode="variable">
		<xsl:param name="initialOpName"/>

		<genutil:trace message="Event Message Variables" select="."/>
		
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		
		<xsl:if test="generate-id(.)=generate-id(key('events', $event)[1])">

			<xsl:for-each select="deploymentpkg:input-parts($bsmxslhelper,$event, 'yes')/part">
				<genutil:trace message="name " select="@name"/>
				<genutil:trace message="type " select="@type"/>
				<xsl:element name="variable">
					<xsl:attribute name="name"><xsl:value-of select="@operation"/><xsl:text>_Input_</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
                    <xsl:choose>
                        <xsl:when test="@type">
                            <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
                        </xsl:when>
                        <xsl:when test="@element">
                            <xsl:attribute name="element"><xsl:value-of select="@element"/></xsl:attribute>
                        </xsl:when>
                        <xsl:otherwise>
                            <genutil:trace message="unrecognized variable type for variable " select="@name"/>
                        </xsl:otherwise>
                    </xsl:choose>
                    <genutil:trace message="does property exist" select="./property"/>
                    <xsl:if test="./property">
                        <xsl:element name="wpc:queryProperties">
                          <xsl:for-each select="./property">
                              <xsl:element name="wpc:queryProperty">
                                  <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                                  <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
                                  <xsl:if test="@query">
                                      <xsl:element name="wpc:query">
                                          <xsl:value-of select="@query"/>
                                      </xsl:element>
                                  </xsl:if>
                              </xsl:element>
                          </xsl:for-each>
                        </xsl:element>
                    </xsl:if>
				</xsl:element>
			</xsl:for-each>

			<xsl:if test="deploymentpkg:output-type($bsmxslhelper,$event)">

                <xsl:for-each select="deploymentpkg:output-parts($bsmxslhelper,$event, 'yes')/part">
                    <genutil:trace message="name " select="@name"/>
                    <genutil:trace message="type " select="@type"/>
                    <xsl:element name="variable">
                        <xsl:attribute name="name"><xsl:value-of select="@operation"/><xsl:text>_Output_</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
                        <xsl:choose>
                            <xsl:when test="@type">
                                <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
                            </xsl:when>
                            <xsl:when test="@element">
                                <xsl:attribute name="element"><xsl:value-of select="@element"/></xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                                <genutil:trace message="unrecognized variable type for variable " select="@name"/>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:if test="./property">
                            <xsl:element name="wpc:queryProperties">
                              <xsl:for-each select="./property">
                                  <xsl:element name="wpc:queryProperty">
                                      <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                                      <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
                                      <xsl:if test="@query">
                                          <xsl:element name="wpc:query">
                                              <xsl:value-of select="@query"/>
                                          </xsl:element>
                                      </xsl:if>
                                  </xsl:element>
                              </xsl:for-each>
                            </xsl:element>
                        </xsl:if>
                    </xsl:element>
                </xsl:for-each>			
            </xsl:if>

        </xsl:if>
	</xsl:template>

	<!-- Add one partnerLink for each reference -->
	<xsl:template match="sacl:interface">
		<xsl:element name="partnerLink">
			<xsl:attribute name="name">
				<xsl:value-of select="substring-after(@portType,':')"/>
			</xsl:attribute>
			<xsl:attribute name="partnerLinkType">artifacts:<xsl:value-of select="substring-after(@portType,':')"/><xsl:text>PLT</xsl:text></xsl:attribute>
			<xsl:attribute name="myRole"><xsl:value-of select="substring-after(@portType,':')"/>Role</xsl:attribute>			
		</xsl:element>
	</xsl:template>

	<xsl:template match="sacl:reference">
		<xsl:for-each select="sacl:interface">
		<xsl:element name="partnerLink">
			<xsl:attribute name="name">
				<xsl:value-of select="../@name"/>
			</xsl:attribute>
			<xsl:attribute name="partnerLinkType">artifacts:<xsl:value-of select="../@name"/><xsl:text>PLT</xsl:text></xsl:attribute>
			<xsl:attribute name="partnerRole"><xsl:value-of select="substring-after(@portType,':')"/>Role</xsl:attribute> 

            <xsl:choose>
                <xsl:when test="../@templateName">
                    <xsl:element name="wpc:processResolver">
                        <xsl:attribute name="processTemplateName"><xsl:value-of select="../@templateName"/></xsl:attribute>
                    </xsl:element>
                </xsl:when>
            </xsl:choose>

		</xsl:element>
		</xsl:for-each>
	</xsl:template>

	<!-- *** PROCESS STRUCTURE ******************************************** -->
	<xsl:template match="sacl:initialState" mode="init">
		<xsl:variable name="source" select="@name"/>
		<xsl:variable name="trans" select="../sacl:transition[sacl:sourceState = $source]"/>

		<xsl:variable name="initialDisplayName">
            <xsl:choose>
                <xsl:when test="string(@displayName)">
                    <xsl:value-of select="@displayName"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:text>undefined</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>

        <genutil:trace message="match=/ mode=init Initial state name=" select="concat(@name, concat(' display name=', $initialDisplayName))"/>

		<xsl:variable name="stateName">
            <xsl:choose>
                <xsl:when test="../../sacl:compositeStateMachine[@name = $trans/sacl:targetState]">
                    <xsl:value-of select="../../sacl:compositeStateMachine[@name = $trans/sacl:targetState]/sacl:initialState/@name"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$trans/sacl:targetState"/>
                </xsl:otherwise>
            </xsl:choose>
		</xsl:variable>

        <genutil:trace message="match=/ mode=init 2nd state=" select="$stateName"/>
		
        <xsl:variable name="event">
			<xsl:value-of select="$trans/sacl:operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="$trans/sacl:operation/@name"/>
		</xsl:variable>

		<!-- Process instantiation -->
		<xsl:element name="receive">
			<xsl:attribute name="name">
				<xsl:text>Receive</xsl:text><xsl:value-of select="$trans/sacl:operation/@name"/>
			</xsl:attribute>
 			<xsl:attribute name="createInstance">yes</xsl:attribute>
			<xsl:attribute name="partnerLink">
				<xsl:value-of select="substring-after($trans/sacl:operation/@portType,':')"/>
			</xsl:attribute>
			<xsl:attribute name="portType"><xsl:value-of select="$trans/sacl:operation/@portType"/></xsl:attribute>
			<xsl:attribute name="operation"><xsl:value-of select="$trans/sacl:operation/@name"/></xsl:attribute>
			<xsl:variable name="debugSourceId" select="@name"/>
			<xsl:attribute name="wpc:displayName">
				<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=START</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
            <xsl:choose>
                <xsl:when test="$trans/sacl:operation/sacl:correlations/sacl:correlation[@initiate='response']">
                </xsl:when>
                <xsl:otherwise>
                    <xsl:element name="correlations">
                        <xsl:element name="correlation">
                            <xsl:attribute name="initiate">yes</xsl:attribute>
                            <xsl:attribute name="set">
                                <xsl:value-of select="/*/sacl:correlationSet/@name"/>
                            </xsl:attribute>
                        </xsl:element>
                    </xsl:element>
                </xsl:otherwise>
            </xsl:choose>
			<xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
				<xsl:apply-templates select="$trans/sacl:operation" mode="addWpcInputParamters"/>
			</xsl:element>
		</xsl:element>
		
		<!-- notify runtime that process is initializing -->
		<xsl:call-template name="ExecuteJavaCode">
			<xsl:with-param name="code">
            <xsl:if test="/*/*/sacl:transition/sacl:guard">GuardValue = Boolean.FALSE;
            </xsl:if>

            <xsl:choose>
                <xsl:when test="/sacl:stateMachineDefinition/@validFrom">
            String id = processInstance().getID().toString() + "#0#<xsl:value-of select="/sacl:stateMachineDefinition/@targetNamespace"/>#1#<xsl:value-of select="/sacl:stateMachineDefinition/@name"/>#2#<xsl:value-of select="/sacl:stateMachineDefinition/@validFrom"/>";
                </xsl:when>
                <xsl:otherwise>
            String id = processInstance().getID().toString() + "#0#<xsl:value-of select="/sacl:stateMachineDefinition/@targetNamespace"/>#1#<xsl:value-of select="/sacl:stateMachineDefinition/@name"/>";
                </xsl:otherwise>
            </xsl:choose>

            ServiceManager sm = ServiceManager.INSTANCE;
            BOFactory factory = (BOFactory) sm.locateService("com/ibm/websphere/bo/BOFactory");
            BSMState_Input_ = factory.create("<xsl:value-of select="/sacl:stateMachineDefinition/@targetNamespace"/>-<xsl:value-of select="/sacl:stateMachineDefinition/@name"/>-bpelartifacts", "runtimeStateType");
                                               
            BSMState_Input_.setString("Id", id);
            BSMState_Input_.setString("ActState", "<xsl:value-of select="$source"/>");
            BSMState_Input_.setString("DisplayState", "<xsl:value-of select="$initialDisplayName"/>");
            BSMState_Input_.setString("ActTrans", "<xsl:value-of select="$trans/@name"/>");
            BSMState_Input_.setString("NxtState", "<xsl:value-of select="$stateName"/>");
            BSMState_Input_.setString("NxtTrans", "<xsl:value-of select="$trans/@name"/>");
            <xsl:if test="/*/*/sacl:transition[@internal='true']">BSMState_Input_.setBoolean("SkipEntry", false);
            </xsl:if>
            <xsl:if test="/*/*/*/sacl:entry">BSMState_Input_.setBoolean("InEntry", false);
            </xsl:if>
            <xsl:if test="/*/*/*/sacl:exit">BSMState_Input_.setBoolean("InExit", false);
            </xsl:if>
            <xsl:if test="/*/*/*/sacl:action">BSMState_Input_.setBoolean("InTransition", false);
            </xsl:if>
            <xsl:if test="/*/*/sacl:transition[sacl:automatic|sacl:duration|sacl:expiration]/sacl:guard">BSMState_Input_.setInt("GuardCnt", 0);
            </xsl:if>
			<xsl:for-each select="//sacl:transition/sacl:duration">BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", 252981792000000L);
            </xsl:for-each>
			<xsl:for-each select="//sacl:transition/sacl:expiration">BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", 252981792000000L);
            </xsl:for-each>

            com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.receivedInitializingMessage(BSMState_Input_, this,"<xsl:value-of select="substring-after($trans/sacl:operation/@portType,':')"/>","<xsl:value-of select="$trans/sacl:operation/@name"/>",new Object[]{
         		<xsl:for-each select="deploymentpkg:input-parts($bsmxslhelper,$event, 'no')/part">
         			<xsl:value-of select="@operation"/><xsl:text>_Input_</xsl:text><xsl:value-of select="@name"/>
         			<xsl:if test="position()&lt;last()">
         				<xsl:text>,</xsl:text>
         			</xsl:if>	
         		</xsl:for-each>});
			</xsl:with-param>
		</xsl:call-template>

		<!-- Main process structure -->	
		<xsl:element name="while">
			<xsl:attribute name="name">StateMachineEventCycle</xsl:attribute>
			
            <xsl:call-template name="addCondition"> 
				<xsl:with-param name="cond">
					<xsl:text>return com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.isFinalOrTerminateState(BSMState_Input_, this) == false;</xsl:text>
				</xsl:with-param>
			</xsl:call-template>

			<!-- Build loop structure -->
				<xsl:element name="scope">
                    <xsl:attribute name="name">StateMachineGlobalScope</xsl:attribute>
                    <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
					<xsl:element name="faultHandlers">
                          <xsl:element name="catch">
                              <xsl:attribute name="faultName"><xsl:text>wpc:runtimeFailure</xsl:text></xsl:attribute>
                              <xsl:attribute name="faultVariable">JavaRuntimeFailureData</xsl:attribute>
                              <xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">artifacts:runtimeFailureType</xsl:attribute>
                              <xsl:call-template name="ExecuteJavaCode">
                                  <xsl:with-param name="code">if (BSMState_Input_.isSet("GuardCnt") &amp;&amp; BSMState_Input_.getInt("GuardCnt") != 0)
                                      {
                                           com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(BSMState_Input_, this,BSMState_Input_.getString("GuardName"),JavaRuntimeFailureData);
                                      }
                                      else if (BSMState_Input_.isSet("InEntry") &amp;&amp; BSMState_Input_.getBoolean("InEntry"))
                                      {
                                           com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.entryActionFailure(BSMState_Input_, this, JavaRuntimeFailureData);
                                      }
                                      else if (BSMState_Input_.isSet("InExit") &amp;&amp; BSMState_Input_.getBoolean("InExit"))
                                      {
                                           com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.exitActionFailure(BSMState_Input_, this, JavaRuntimeFailureData);
                                      }
                                      else if (BSMState_Input_.isSet("InTransition") &amp;&amp; BSMState_Input_.getBoolean("InTransition"))
                                      {
                                          com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, true, JavaRuntimeFailureData);
                                      }
                                      else
                                      {
                                          BSMState_Input_.setString("NxtState", "undef");
                                          BSMState_Input_.setString("NxtTrans", "undef");
                                         <xsl:if test="/*/*/sacl:transition[@internal='true']">BSMState_Input_.setBoolean("SkipEntry", false);</xsl:if>
                                      }</xsl:with-param>
                              </xsl:call-template>
                          </xsl:element>
                          <xsl:element name="catch">
                              <xsl:attribute name="faultVariable">AnyTypeData</xsl:attribute>
                              <xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">xsd:anyType</xsl:attribute>
                              <xsl:call-template name="ExecuteJavaCode">
                                  <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                                      String faultName = ex.getFaultName();

                                      Hashtable faultDataHT = new Hashtable();
                                      faultDataHT.put("faultName", faultName);
                                      faultDataHT.put("faultData", AnyTypeData);

                                      if (BSMState_Input_.isSet("GuardCnt") &amp;&amp; BSMState_Input_.getInt("GuardCnt") != 0)
                                      {
                                           com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(BSMState_Input_, this,BSMState_Input_.getString("GuardName"),faultDataHT);
                                      }
                                      else if (BSMState_Input_.isSet("InEntry") &amp;&amp; BSMState_Input_.getBoolean("InEntry"))
                                      {
                                           com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.entryActionFailure(BSMState_Input_, this, faultDataHT);
                                      }
                                      else if (BSMState_Input_.isSet("InExit") &amp;&amp; BSMState_Input_.getBoolean("InExit"))
                                      {
                                           com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.exitActionFailure(BSMState_Input_, this, faultDataHT);
                                      }
                                      else if (BSMState_Input_.isSet("InTransition") &amp;&amp; BSMState_Input_.getBoolean("InTransition"))
                                      {
                                          com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, true, faultDataHT);
                                      }
                                      else
                                      {
                                          BSMState_Input_.setString("NxtState", "undef");
                                          BSMState_Input_.setString("NxtTrans", "undef");
                                         <xsl:if test="/*/*/sacl:transition[@internal='true']">BSMState_Input_.setBoolean("SkipEntry", false);</xsl:if>
                                      }</xsl:with-param>
                              </xsl:call-template>
                          </xsl:element>
                          <xsl:element name="catchAll">
                              <xsl:call-template name="ExecuteJavaCode">
                                  <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                                      String faultName = ex.getFaultName();
                                      QName faultQName = null;

                                      if ("SACL_Deadlock".equals(faultName))
                                      {
                                           com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.instanceEnding(BSMState_Input_, this, "sacl:deadlock");
                                           faultQName = new QName("http://www.ibm.com/xmlns/prod/websphere/wbi/sacl/6.0.0", "SACL_Deadlock", "sacl");  
                                           raiseFault(faultQName);
                                      }

                                      else if ("SACL_Fault".equals(faultName))
                                      {
                                          if (BSMState_Input_.getString("ActState").equals("<xsl:value-of select="$source"/>"))
                                          {
                                              com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.instanceEnding(BSMState_Input_, this, "Exception during initialization");
                                              faultQName = new QName("http://www.ibm.com/xmlns/prod/websphere/wbi/sacl/6.0.0", "SACL_InitialTransitionFault", "sacl");
                                              raiseFault(faultQName);
                                          }

                                          if (BSMState_Input_.isSet("InTransition") == false || BSMState_Input_.getBoolean("InTransition") == false)
                                          {
                                              BSMState_Input_.setString("NxtState", "undef");
                                              BSMState_Input_.setString("NxtTrans", "undef");
                                              <xsl:if test="/*/*/sacl:transition[@internal='true']">BSMState_Input_.setBoolean("SkipEntry", false);</xsl:if>
                                          }
                                      }

                                      else
                                      {
                                          if (BSMState_Input_.isSet("GuardCnt") &amp;&amp; BSMState_Input_.getInt("GuardCnt") != 0)
                                          {
                                               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(BSMState_Input_, this,BSMState_Input_.getString("GuardName"),faultName);
                                          }
                                          else if (BSMState_Input_.isSet("InEntry") &amp;&amp; BSMState_Input_.getBoolean("InEntry"))
                                          {
                                               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.entryActionFailure(BSMState_Input_, this, faultName);
                                          }
                                          else if (BSMState_Input_.isSet("InExit") &amp;&amp; BSMState_Input_.getBoolean("InExit"))
                                          {
                                               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.exitActionFailure(BSMState_Input_, this, faultName);
                                          }
                                          else if (BSMState_Input_.isSet("InTransition") &amp;&amp; BSMState_Input_.getBoolean("InTransition"))
                                          {
                                               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, true, faultName);
                                          }
                                          else
                                          {
                                               BSMState_Input_.setString("NxtState", "undef");
                                               BSMState_Input_.setString("NxtTrans", "undef");
                                               <xsl:if test="/*/*/sacl:transition[@internal='true']">BSMState_Input_.setBoolean("SkipEntry", false);</xsl:if>
                                          }
                                      }</xsl:with-param>
                              </xsl:call-template>
                          </xsl:element>
					</xsl:element>

                    <xsl:element name="sequence">
                        <xsl:attribute name="name">StateMachineEventSequence</xsl:attribute>

                        <genutil:trace message="================================ AtomicTransitionInProgress ===============================" select="."/>

                        <xsl:choose>
                            <xsl:when test="/*/*/*/sacl:action">
                                <xsl:element name="switch">
                                    <xsl:attribute name="name">AtomicTransitionInProgress</xsl:attribute>
                                    <xsl:element name="case">
                                        <xsl:call-template name="addCondition">
                                            <xsl:with-param name="cond">return (!BSMState_Input_.getBoolean("InTransition"));</xsl:with-param>
                                        </xsl:call-template>
                                        <xsl:element name="sequence">
                                            <xsl:call-template name="AtomicTransitionInProgressBody"/>
                                        </xsl:element>
                                    </xsl:element>
                                </xsl:element>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:call-template name="AtomicTransitionInProgressBody"/>
                            </xsl:otherwise>
                        </xsl:choose>

                        <genutil:trace message="================================ Timer Reset ===============================" select="."/>

                        <xsl:apply-templates select="/*/*/sacl:compositeState" mode="timer"/>

                        <genutil:trace message="============================ Debug Requirement =============================" select="."/>

                        <!-- create a debugger stopping point for the second state -->
                        <xsl:element name="switch">
                            <xsl:attribute name="name">DebuggerStoppingPoint</xsl:attribute>
                            <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">5000</xsl:attribute>
                            <xsl:element name="case">
                                <xsl:call-template name="addCondition">
                                    <xsl:with-param name="cond">
                                        <xsl:text>return BSMState_Input_.getString("ActState").equals("</xsl:text>
                                        <xsl:value-of select="$source"/>
                                        <xsl:text>");</xsl:text>
                                    </xsl:with-param>
                                </xsl:call-template>
                                <xsl:element name="empty">
                                    <xsl:variable name="debugSourceId" select="$stateName"/>
                                    <xsl:attribute name="wpc:displayName">
                                        <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=START</xsl:text>
                                    </xsl:attribute>
                                    <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
                                </xsl:element>
                            </xsl:element>
                        </xsl:element>

                        <genutil:trace message="====================== Update ActState and DisplayState ====================" select="."/>

                        <xsl:call-template name="ExecuteJavaCode">
                            <xsl:with-param name="code">
                              String  displayState = com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.stateChanging(BSMState_Input_, this);
                              BSMState_Input_.setString("DisplayState", displayState);
                              <xsl:choose>
                                 <xsl:when test="/*/*/sacl:transition[@internal='true']">
                                       <xsl:text>if(!BSMState_Input_.getBoolean("SkipEntry")) {</xsl:text>
                                 </xsl:when>
                              </xsl:choose>
                              <xsl:apply-templates select="/*/*/sacl:state" mode="timer"/>
                              <xsl:choose>
                                 <xsl:when test="/*/*/sacl:transition[@internal='true']">
                                       <xsl:text>}</xsl:text>
                                 </xsl:when>
                              </xsl:choose>
                              <xsl:choose>
                                 <xsl:when test="/*/*/sacl:transition/sacl:action">
                                 </xsl:when>
                                 <xsl:otherwise>
                                     <xsl:if test="/*/*/*/sacl:exit">BSMState_Input_.setBoolean("InExit", false);
                                     </xsl:if>
                                 </xsl:otherwise>
                              </xsl:choose>
                              <xsl:if test="/*/*/*/sacl:action">
                              BSMState_Input_.setBoolean("InTransition", false);
                              </xsl:if>
                              BSMState_Input_.setString("ActState", BSMState_Input_.getString("NxtState"));
                              BSMState_Input_.setString("ActTrans", BSMState_Input_.getString("NxtTrans"));
                              BSMState_Input_.setString("NxtState", "undef");
                              BSMState_Input_.setString("NxtTrans", "undef");
                            </xsl:with-param>
                        </xsl:call-template>

                        <genutil:trace message="====================== Entry Actions and Timer Setting =====================" select="."/>

                        <xsl:if test="/*/*/*/sacl:entry | /*/*/sacl:transition[@internal='true'] | /*/*/sacl:transition/sacl:duration | /*/*/sacl:transition/sacl:expiration">
                            <xsl:call-template name="EntryActionPreInvoke"/>

                            <xsl:element name="switch">
                                <xsl:attribute name="name">HandleEntryActions</xsl:attribute>
                                <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nostate')"/></xsl:attribute>
                                <xsl:choose>
                                    <xsl:when test="/*/*/sacl:transition[@internal='true']">
                                        <xsl:element name="case">
                                            <xsl:call-template name="addCondition">
                                                <xsl:with-param name="cond">return (BSMState_Input_.getBoolean("SkipEntry"));</xsl:with-param>
                                            </xsl:call-template>
                                            <xsl:call-template name="ExecuteJavaCode">
                                                <xsl:with-param name="code">
                                                      BSMState_Input_.setBoolean("SkipEntry", false);
                                                </xsl:with-param>
                                            </xsl:call-template>
                                        </xsl:element>
                                    </xsl:when>
                                </xsl:choose>
                                <xsl:apply-templates select="/*/*/sacl:state" mode="entry"/>
                                <xsl:apply-templates select="/*/*/sacl:compositeState" mode="entry"/>
                                <xsl:apply-templates select="/*/*/sacl:finalState" mode="entry"/>								
                                <xsl:apply-templates select="/*/*/sacl:terminateState" mode="entry"/>
                            </xsl:element>

                            <xsl:call-template name="EntryActionPostInvoke"/>
                        </xsl:if>

                    </xsl:element>
				</xsl:element>
		</xsl:element>

        <xsl:if test="/*/*/sacl:terminateState">	
            <xsl:element name="switch">
                <xsl:attribute name="name">HandleTerminateStates</xsl:attribute>

                <xsl:element name="case">
                    <xsl:call-template name="addCondition">
                        <xsl:with-param name="cond">
                            <xsl:text>
                                         return com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.isTerminateState(BSMState_Input_, this);</xsl:text>
                        </xsl:with-param>
                    </xsl:call-template>

                    <xsl:element name="terminate">
                        <xsl:attribute name="name">
                            <xsl:text>terminate_state</xsl:text>
                        </xsl:attribute>
                    </xsl:element>
                    </xsl:element>

            </xsl:element>
        </xsl:if>					

		<xsl:call-template name="ExecuteJavaCode">
			<xsl:with-param name="code">
               /**
                *@bpe.readOnlyVariables names="BSMState_Input_"
                */
                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.instanceEnding(BSMState_Input_, this, "Final State");</xsl:with-param>
		</xsl:call-template>

        <genutil:trace message="==============================  X S L T    E N D I N G   ===================================" select="."/>

	</xsl:template>
	
	<xsl:template name="AtomicTransitionInProgressBody">
        <xsl:choose>
            <xsl:when test="/*/*/*/sacl:exit">
                <xsl:element name="switch">
                    <xsl:attribute name="name">ExitActionInProgressCheck</xsl:attribute>
                    <xsl:element name="case">
                        <xsl:call-template name="addCondition">
                            <xsl:with-param name="cond">return (!BSMState_Input_.getBoolean("InExit"));</xsl:with-param>
                        </xsl:call-template>
                        <xsl:element name="sequence">
                            <xsl:call-template name="TransitionSelection"/>
                            <xsl:call-template name="ExecuteJavaCode">
                                <xsl:with-param name="code">
                                    <xsl:if test="/*/*/*/sacl:entry">
                                        <xsl:text>BSMState_Input_.setBoolean("InEntry", false);
                                        </xsl:text>
                                    </xsl:if>
                                    <xsl:if test="/*/*/*/sacl:exit">BSMState_Input_.setBoolean("InExit", true);
                                    </xsl:if>
                                    <xsl:if test="/*/*/sacl:transition/sacl:guard">
                                        <xsl:text>GuardValue = Boolean.FALSE;
                                        </xsl:text>
                                    </xsl:if>
                                    <xsl:if test="/*/*/sacl:transition[sacl:automatic|sacl:duration|sacl:expiration]/sacl:guard">
                                        <xsl:text>BSMState_Input_.setInt("GuardCnt", 0);
                                        </xsl:text>
                                    </xsl:if>
                                         com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionSelected(BSMState_Input_, this);
                                         com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.exitActionPreinvoke(BSMState_Input_, this);
                                </xsl:with-param>
                            </xsl:call-template> 
                            <xsl:element name="switch">
                                <xsl:attribute name="name">SimpleStateExitActions</xsl:attribute>
                                <xsl:choose>
                                    <xsl:when test="/*/*/sacl:transition[@internal='true']">
                                        <xsl:element name="case">
                                            <xsl:call-template name="addCondition">
                                                <xsl:with-param name="cond">return (BSMState_Input_.getBoolean("SkipEntry"));</xsl:with-param>
                                            </xsl:call-template>
                                            <xsl:element name="empty"/>
                                        </xsl:element>
                                    </xsl:when>
                                </xsl:choose>
                                <xsl:apply-templates select="/*/*/sacl:state" mode="exit"/>
                            </xsl:element>
                            <xsl:call-template name="ExecuteJavaCode">
                                <xsl:with-param name="code">
                                     BSMState_Input_.setBoolean("InExit", false);
                                     com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.exitActionPostinvoke(BSMState_Input_, this);
                                </xsl:with-param>
                            </xsl:call-template> 
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <xsl:call-template name="TransitionSelection"/>
                <xsl:call-template name="ExecuteJavaCode">
                    <xsl:with-param name="code">
                        <xsl:if test="/*/*/*/sacl:entry"><xsl:text>BSMState_Input_.setBoolean("InEntry", false);</xsl:text></xsl:if>
                        <xsl:if test="/*/*/sacl:transition/sacl:guard"><xsl:text>GuardValue = Boolean.FALSE;</xsl:text></xsl:if>
                        <xsl:if test="/*/*/sacl:transition[sacl:automatic|sacl:duration|sacl:expiration]/sacl:guard"><xsl:text>BSMState_Input_.setInt("GuardCnt", 0);</xsl:text></xsl:if>
                               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionSelected(BSMState_Input_, this);
                    </xsl:with-param>
                </xsl:call-template> 
            </xsl:otherwise>
        </xsl:choose>

        <genutil:trace message="=============================== Composite Exit Actions ===============================" select="."/>

        <xsl:if test="/*/*/*/sacl:exit">	
            <xsl:call-template name="handleCompositeExitActions"/>
        </xsl:if>

        <genutil:trace message="===================== Transition Actions and Replies =======================" select="."/>

        <!-- Arrange transition actions -->
        <xsl:if test="/*/*/sacl:transition/sacl:operation | /*/*/sacl:transition/sacl:action">	
            <xsl:if test="/*/*/sacl:transition/sacl:action">
                <xsl:call-template name="TransitionActionPreInvoke"/>
            </xsl:if>
            <xsl:element name="switch">
                <xsl:attribute name="name">HandleTransitionActions</xsl:attribute>
                <xsl:apply-templates select="/*/*/sacl:transition" mode="execute"/>
            </xsl:element>
            <xsl:if test="/*/*/sacl:transition/sacl:action">
                <xsl:call-template name="TransitionActionPostInvoke"/>
            </xsl:if>
        </xsl:if>
	</xsl:template>

    <xsl:template name="TransitionSelection">

        <genutil:trace message="=========================== Transition Selection ===========================" select="."/>

        <xsl:if test="(count(/*/*/sacl:transition[sacl:automatic]) - count(/*/*/sacl:transition[sacl:automatic]/sacl:guard) + count(/*/sacl:compositeStateMachine/sacl:initialState) + count(/*/sacl:compositeStateMachine/sacl:finalState)) > 0">
            <xsl:call-template name="ExecuteJavaCode">
                <xsl:with-param name="code">
                    String activeState = BSMState_Input_.getString("ActState");

                    if (BSMState_Input_.getString("NxtTrans").equals("undef") == false)
                    {
                    }                     
                    <xsl:apply-templates select="/*/sacl:compositeStateMachine/sacl:initialState" mode="unguardedAuto"/>
                    <xsl:apply-templates select="/*/sacl:compositeStateMachine/sacl:finalState" mode="unguardedAuto"/>
                    <xsl:apply-templates select="/*/*/sacl:state" mode="unguardedAuto"/>
                </xsl:with-param>
            </xsl:call-template>
        </xsl:if>

        <xsl:if test="count(/*/*/sacl:transition[sacl:automatic]/sacl:guard)> 0">
            <!-- Select guarded automatic transitions -->
            <xsl:element name="switch">
                <xsl:attribute name="name">SelectForGuardedAutomatics</xsl:attribute>
                <xsl:element name="case">
                    <xsl:call-template name="addCondition">
                        <xsl:with-param name="cond">
                            <xsl:text>return (BSMState_Input_.getString("NxtTrans").equals("undef") == false);</xsl:text>
                        </xsl:with-param>
                    </xsl:call-template>
                    <xsl:element name="empty"/>
                </xsl:element> 
                <xsl:apply-templates select="/*/*/sacl:state" mode="guardedAutos"/>
            </xsl:element>
        </xsl:if>

        <!-- Select event driven transitions -->
        <xsl:if test="(count(/*/*/sacl:transition/sacl:operation) + count(/*/*/sacl:transition/sacl:duration) + count(/*/*/sacl:transition/sacl:expiration)) > 0">
            <xsl:element name="while">
                <xsl:attribute name="name">EventWhileLoop</xsl:attribute>
                <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nostate')"/></xsl:attribute>
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">
                    <xsl:text>return (BSMState_Input_.getString("NxtTrans").equals("undef"));</xsl:text>
                    </xsl:with-param>
                </xsl:call-template>
                <xsl:element name="pick">
                    <xsl:attribute name="name">PickEvents</xsl:attribute>
                    <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nostate')"/></xsl:attribute>
                    <xsl:apply-templates select="/*/*/sacl:transition[sacl:operation]" mode="onMessage"/>
                    <xsl:apply-templates select="/*/*/sacl:transition[sacl:expiration|sacl:duration]" mode="onAlarm"/>
                </xsl:element>
            </xsl:element>
        </xsl:if>

    </xsl:template>

	<xsl:template name="addCondition">
        <xsl:param name="cond" select="'return true;'"/>
		<xsl:element name="condition">
			<xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
			<xsl:value-of select="$cond"/>
		</xsl:element>
	</xsl:template>

	<!-- *** ENTRY ACTIONS ************************************************ -->

	<!-- Add a entry action for "normal" states -->
	<xsl:template match="sacl:terminateState | sacl:state | sacl:finalState" mode="entry">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="timeout" select="../sacl:transition[sacl:sourceState = $state][sacl:duration|sacl:expiration]"/>
		<xsl:if test="sacl:entry|$timeout">
            <xsl:element name="case">
            <!-- Build case condition -->
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">
                        <xsl:text>return (BSMState_Input_.getString("ActState").equals("</xsl:text>
                        <xsl:value-of select="@name"/>
                        <xsl:text>"));</xsl:text>
                    </xsl:with-param>
                </xsl:call-template>
				<!-- Add structure -->
				<xsl:choose>
					<xsl:when test="sacl:entry">
						<xsl:choose>
							<xsl:when test="$timeout">
								<xsl:element name="sequence">
                                    <xsl:apply-templates select="." mode="setTimer"/>
									<xsl:apply-templates select="sacl:entry" mode="invokeSimple"/>
								</xsl:element>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="sacl:entry" mode="invokeSimple"/>
							</xsl:otherwise>	
						</xsl:choose>			
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="." mode="setTimer"/>
					</xsl:otherwise>	
				</xsl:choose>
            </xsl:element>
		</xsl:if>	
	</xsl:template>
	
	<!-- Add a entry action for composite states -->
	<xsl:template match="sacl:compositeState" mode="entry">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="timeout" select="../sacl:transition[sacl:sourceState = $state][sacl:duration|sacl:expiration]"/>
		<xsl:if test="sacl:entry|$timeout">
			<xsl:element name="case">
				<!-- Build case condition -->
				<xsl:call-template name="addCondition">
					<xsl:with-param name="cond">
						<xsl:text>return ((</xsl:text>
						<xsl:for-each select="../sacl:transition[sacl:targetState = $state]">
							<xsl:text>BSMState_Input_.getString("ActTrans").equals("</xsl:text><xsl:value-of select="./@name"/><xsl:text>")</xsl:text>
							<xsl:if test="position()&lt;last()">
								<xsl:text> || </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>));</xsl:text>
					</xsl:with-param>
				</xsl:call-template>
				<!-- Add structure -->
				<xsl:choose>
					<xsl:when test="sacl:entry">
						<xsl:choose>
							<xsl:when test="$timeout">
								<xsl:element name="sequence">
                                    <xsl:apply-templates select="." mode="setTimer"/>
									<xsl:apply-templates select="sacl:entry" mode="invokeSimple"/>
								</xsl:element>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="sacl:entry" mode="invokeSimple"/>
							</xsl:otherwise>	
						</xsl:choose>			
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="." mode="setTimer"/>
					</xsl:otherwise>	
				</xsl:choose>
			</xsl:element>
		</xsl:if>	
	</xsl:template>
	
	<!-- Set timer variables -->
	<xsl:template match="sacl:state|sacl:compositeState" mode="setTimer">
		<xsl:variable name="state" select="@name"/>
				
		<xsl:if test="../sacl:transition[sacl:sourceState = $state]/sacl:expiration or ../sacl:transition[sacl:sourceState = $state]/sacl:duration">
            <xsl:element name="invoke">
                <xsl:attribute name="name"><xsl:value-of select="@name"/><xsl:text>.setTimer</xsl:text></xsl:attribute>
                <xsl:attribute name="partnerLink">null</xsl:attribute>
                <xsl:attribute name="portType">wpc:null</xsl:attribute>
                <xsl:attribute name="operation">null</xsl:attribute>

                <xsl:variable name="debugSourceId" select="@name"/>
                <xsl:attribute name="wpc:displayName">
                    <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Timer</xsl:text>
                </xsl:attribute>
                <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>

                <xsl:variable name="code">
                    <xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:expiration">
                        <xsl:choose>
                            <xsl:when test="sacl:value">
                                java.util.Calendar cal = java.util.Calendar.getInstance(java.util.TimeZone.getTimeZone("GMT"));				
                                cal.set(<xsl:value-of select="."/>);
                                 BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", cal.getTime().getTime());
                            </xsl:when>
                            <xsl:when test="sacl:javaCode">
                                BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", 0L);
                            </xsl:when>
                        </xsl:choose>
                    </xsl:for-each>

                    <xsl:choose>
                        <xsl:when test="../sacl:transition[sacl:sourceState = $state]/sacl:duration">
                            String timerValStr;
                            long timerValueL;
                        </xsl:when>
                    </xsl:choose>

                    <xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:duration">
                        <xsl:choose>
                            <xsl:when test="sacl:value">
                                timerValStr = com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.evaluateDuration("<xsl:value-of select="sacl:value"/>");
                                timerValueL = 252981792000000L;
                                try { timerValueL = Long.parseLong(timerValStr);}
                                catch(Exception e) {}    // this should never happen
                                BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", timerValueL);
                            </xsl:when>
                            <xsl:when test="sacl:javaCode">
                                BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", 0L);
                            </xsl:when>
                        </xsl:choose>
                    </xsl:for-each>
                </xsl:variable>	

                <xsl:element name="wpc:script">
                    <wpc:javaCode>
                        <xsl:value-of select="$code"/>
                    </wpc:javaCode>
                </xsl:element>
            </xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- *** AUTOMATIC TRANSITIONS **************************************** -->

	<!-- Add a automatic transitions for "normal" states -->
	<xsl:template match="sacl:state" mode="guardedAutos">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="/*/*/sacl:transition[sacl:automatic][sacl:sourceState=$state]"/>
		<xsl:if test="$trans">
			<xsl:element name="case">
				<xsl:call-template name="addCondition">
					<xsl:with-param name="cond">
						<xsl:text>return BSMState_Input_.getString("ActState").equals("</xsl:text>
						<xsl:value-of select="$state"/>
						<xsl:text>");</xsl:text>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="addStateTransitionCheckForAutos">
					<xsl:with-param name="trans" select="$trans"/>
				</xsl:call-template>						
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- Add a automatic transitions for "normal" states -->
	<xsl:template match="sacl:state" mode="unguardedAuto">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="/*/*/sacl:transition[sacl:automatic][sacl:sourceState=$state]"/>
		<xsl:if test="$trans">
            <xsl:choose>
                <xsl:when test="count($trans/sacl:guard) = 0">
                    <xsl:call-template name="addSimpleAutoTrans">
                        <xsl:with-param name="state" select="$state"/>
                        <xsl:with-param name="trans" select="$trans"/>
                    </xsl:call-template>
                </xsl:when>
            </xsl:choose>
		</xsl:if>
	</xsl:template>
	
	<!-- Add a automatic transitions for initial states (composites) -->
	<xsl:template match="sacl:initialState" mode="unguardedAuto">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="/*/*/sacl:transition[sacl:automatic][sacl:sourceState=$state]"/>
		<xsl:choose>
			<xsl:when test="$trans">
				<genutil:trace message="Automatic transition is defined in the sacl from the composite initial state" select="$state"/>
				<xsl:call-template name="addSimpleAutoTrans">
					<xsl:with-param name="state" select="$state"/>
					<xsl:with-param name="trans" select="$trans"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<genutil:trace message="No automatic transition is defined in the sacl from the composite initial state" select="$state"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Add a automatic transitions for final states -->
	<xsl:template match="sacl:finalState" mode="unguardedAuto">
		<xsl:variable name="state" select="../@name"/>
		<xsl:variable name="trans" select="/*/*/sacl:transition[sacl:automatic][sacl:sourceState=$state]"/>
		<xsl:if test="$trans">
			<xsl:call-template name="addSimpleAutoTrans">
				<xsl:with-param name="state" select="@name"/>
				<xsl:with-param name="trans" select="$trans"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<!-- Build automatic transition's structure for initial and final states -->
	<xsl:template name="addSimpleAutoTrans">
		<xsl:param name="state"/>
		<xsl:param name="trans"/>
        <xsl:text>else if(activeState.equals("</xsl:text><xsl:value-of select="$state"/><xsl:text>"))
        {
            BSMState_Input_.setString("NxtState", "</xsl:text><xsl:choose><xsl:when test="$trans/../../sacl:compositeStateMachine[./@name = $trans/sacl:targetState]"><xsl:value-of select="$trans/../../sacl:compositeStateMachine[@name = $trans/sacl:targetState]/sacl:initialState/@name"/></xsl:when>
                         <xsl:otherwise><xsl:value-of select="$trans/sacl:targetState"/></xsl:otherwise></xsl:choose><xsl:text>");
            BSMState_Input_.setString("NxtTrans", "</xsl:text><xsl:value-of select="$trans/@name"/><xsl:text>");</xsl:text>
        <xsl:if test="$trans[sacl:sourceState=sacl:targetState][@internal='true']">
            <xsl:text>BSMState_Input_.setBoolean("SkipEntry", true);</xsl:text>
        </xsl:if>
        <xsl:text>
        }
        </xsl:text>
	</xsl:template>		

	<!-- *** EVENT TRIGGERED BRANCHES ************************************* -->

	<!-- Build PickEvent's onMessage branch -->
	
	<xsl:template match="sacl:transition" mode="onMessage">
		<xsl:variable name="event">
			<xsl:value-of select="sacl:operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="sacl:operation/@name"/>
		</xsl:variable>
		<xsl:variable name="trans" select="."/>

		<xsl:variable name="responseOp"><xsl:value-of select="./sacl:operation/sacl:correlations/sacl:correlation/@initiate"/></xsl:variable>
		
        <genutil:trace message="match=sacl:transition mode=onMesage initiate = " select="$responseOp"/>
        <genutil:trace message="match=sacl:transition mode=onMesage count(//sacl:operation) = " select="count(//sacl:operation)"/>
        
        <xsl:choose>
            <xsl:when test="$responseOp = 'response' and count(//sacl:operation) > 1">
            </xsl:when>
            <xsl:when test="generate-id(sacl:operation)=generate-id(key('events', $event)[1])">
                <xsl:element name="onMessage">
                    <xsl:attribute name="partnerLink">
                        <xsl:value-of select="substring-after(sacl:operation/@portType,':')"/>
                    </xsl:attribute>
                    <xsl:attribute name="portType"><xsl:value-of select="sacl:operation/@portType"/></xsl:attribute>
                    <xsl:attribute name="operation"><xsl:value-of select="sacl:operation/@name"/></xsl:attribute>
                    <xsl:element name="correlations">
                        <xsl:element name="correlation">
                            <xsl:attribute name="initiate">no</xsl:attribute>
                            <xsl:attribute name="set">
                                <xsl:value-of select="/*/sacl:correlationSet/@name"/>
                            </xsl:attribute>
                        </xsl:element>
                    </xsl:element>
                    <xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                        <xsl:apply-templates select="sacl:operation" mode="addWpcInputParamters"/>
                    </xsl:element>
                    <xsl:element name="sequence">
                        <xsl:attribute name="name">DetermineActStateFor<xsl:value-of select="sacl:operation/@name"/></xsl:attribute>
                        <xsl:call-template name="ExecuteJavaCode">
                            <xsl:with-param name="code">
                                     /**
                                      *@bpe.readOnlyVariables names="BSMState_Input_"
                                      */

                                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.receivedMessage(BSMState_Input_, this,"<xsl:value-of select="substring-after($trans/sacl:operation/@portType,':')"/>","<xsl:value-of select="$trans/sacl:operation/@name"/>",new Object[]{
                                        <xsl:for-each select="deploymentpkg:input-parts($bsmxslhelper,$event, 'no')/part">
                                            <xsl:value-of select="@operation"/><xsl:text>_Input_</xsl:text><xsl:value-of select="@name"/>
                                            <xsl:if test="position()&lt;last()">
                                            <xsl:text>,</xsl:text>
                                            </xsl:if>
                                        </xsl:for-each>});
                            </xsl:with-param>
                        </xsl:call-template>
                        <xsl:apply-templates select="sacl:operation" mode="switchOnActState"/>
                    </xsl:element>
                </xsl:element>
            </xsl:when>
        </xsl:choose>
	</xsl:template>

	<!-- Build SwitchOnActState for each event -->
	<xsl:template match="sacl:operation" mode="switchOnActState">
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
        <xsl:if test="key('trans', $event)[key('simpleState', sacl:sourceState)]">
            <xsl:if test="count(/*/*/sacl:state) &gt; 0">
                <xsl:element name="switch">
                    <xsl:variable name="debugSourceId" select="@name"/>				
                    <xsl:attribute name="wpc:displayName">
                    <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Event</xsl:text></xsl:attribute>
                    <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>			
                    <xsl:attribute name="name">AnySimpleStatesAccept<xsl:value-of select="@name"/></xsl:attribute>
                    <!-- One case branch for each state accepting the current event -->
                    <xsl:apply-templates select="/*/*/sacl:state" mode="event">
                        <xsl:with-param name="operation" select="."/>
                    </xsl:apply-templates>
                </xsl:element>
            </xsl:if>
        </xsl:if>
        <xsl:if test="key('trans', $event)[key('compositeState', sacl:sourceState)]">
            <xsl:element name="switch">
                <xsl:attribute name="name">IfNoSimpleStateAccepted<xsl:value-of select="@name"/></xsl:attribute>
                <xsl:element name="case">
                    <xsl:call-template name="addCondition">
                        <xsl:with-param name="cond">
                            <xsl:text>return BSMState_Input_.getString("NxtTrans").equals("undef");</xsl:text>
                        </xsl:with-param>
                    </xsl:call-template>
                    <xsl:apply-templates select="." mode="switchOnCompositeState"/>
                </xsl:element>						
            </xsl:element>
        </xsl:if>
        <xsl:element name="switch">
            <xsl:attribute name="name">IfNoStateAccepted<xsl:value-of select="@name"/></xsl:attribute>
            <xsl:element name="case">
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">
                        <xsl:text>return BSMState_Input_.getString("NxtTrans").equals("undef");</xsl:text>
                    </xsl:with-param>
                </xsl:call-template>
                <xsl:element name="sequence">
                    <xsl:apply-templates select="." mode="replyTo">
                        <xsl:with-param name="type" select="'Fault'"/>
                        <xsl:with-param name="FaultMessage">SACL_RuntimeFault[<xsl:value-of  select="deploymentpkg:get-message($bsmxslhelper,'DeployCommand.NoSelectableTransition')"/>]</xsl:with-param>
                    </xsl:apply-templates>
                </xsl:element>
            </xsl:element>						
        </xsl:element>
	</xsl:template>	

	<xsl:template match="sacl:operation" mode="switchOnCompositeState">
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<xsl:element name="switch">
			<xsl:attribute name="name">AnyCompositeStatesAccept<xsl:value-of select="@name"/></xsl:attribute>
			<xsl:variable name="debugSourceId" select="@name"/>				
			<xsl:attribute name="wpc:displayName">
			<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Event</xsl:text></xsl:attribute>
			<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>			
			<xsl:apply-templates select="/*/*/sacl:compositeState" mode="event">
				<xsl:with-param name="operation" select="."/>
			</xsl:apply-templates>
		</xsl:element>
	</xsl:template>

	<!-- Build case branch for each "normal" state that can accept the current event -->
	<xsl:template match="sacl:state" mode="event">
		<xsl:param name="operation"/>
		<xsl:variable name="event">
			<xsl:value-of select="$operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="$operation/@name"/>
		</xsl:variable>
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="key('trans', $event)[sacl:sourceState=$state]"/>		
		<xsl:if test="$trans">
			<xsl:element name="case">
				<xsl:call-template name="addCondition">
					<xsl:with-param name="cond">
						<xsl:text>return BSMState_Input_.getString("ActState").equals("</xsl:text>
						<xsl:value-of select="$state"/><xsl:text>");</xsl:text>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="addStateTransitionCheck">
					<xsl:with-param name="trans" select="$trans"/>
				</xsl:call-template>
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- Build case branch for each composite state that can accept the current exception event -->
	<xsl:template match="sacl:compositeState" mode="event">
		<xsl:param name="operation"/>
		<xsl:variable name="event">
			<xsl:value-of select="$operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="$operation/@name"/>
		</xsl:variable>
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="key('trans', $event)[sacl:sourceState=$state]"/>		
		<xsl:if test="$trans">
            <xsl:variable name="currentTran" select="$trans[position()=1]" />
            <xsl:element name="case">
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">
                                 return (com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.executeExitAction(BSMState_Input_, this,"<xsl:value-of select="$currentTran/@name"/>", BSMState_Input_.getString("ActState"),"<xsl:value-of select="$currentTran/sacl:targetState"/>","<xsl:value-of select="$state"/>"));</xsl:with-param>
                </xsl:call-template>
                <xsl:call-template name="addStateTransitionCheck">
                    <xsl:with-param name="trans" select="$trans"/>
                </xsl:call-template>						
            </xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- *** TIMER TRIGGERED BRANCHES ************************************* -->

	<!-- Build PickEvent's onAlarm branch -->
	<xsl:template match="sacl:transition" mode="onAlarm">
		<xsl:variable name="timer">
			<xsl:value-of select="sacl:duration/@name|sacl:expiration/@name"/>
		</xsl:variable>
		<xsl:element name="onAlarm">
			<xsl:choose>
				<xsl:when test="sacl:duration/sacl:javaCode">
					<xsl:element name="for">
						<xsl:attribute name="expressionLanguage"><xsl:text>http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:text></xsl:attribute>
						<xsl:variable name="debugSourceId" select="@name"/>
						<xsl:attribute name="wpc:displayName">
							<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Timer</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
						
                        <xsl:text>if (BSMState_Input_.getLong("</xsl:text><xsl:value-of select="$timer"/><xsl:text>TimerValue") == 0L)
                        {</xsl:text>
					       <xsl:value-of select="sacl:duration/sacl:javaCode"/><xsl:text>
                        }
                        else
                        {
                           return Integer.MAX_VALUE;
                        }</xsl:text>

					</xsl:element>
				</xsl:when>
				<xsl:when test="sacl:expiration/sacl:javaCode">
					<xsl:element name="until">
						<xsl:attribute name="expressionLanguage"><xsl:text>http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:text></xsl:attribute>
						<xsl:variable name="debugSourceId" select="@name"/>
						<xsl:attribute name="wpc:displayName">
							<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Timer</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>

                        <xsl:text>if (BSMState_Input_.getLong("</xsl:text><xsl:value-of select="$timer"/><xsl:text>TimerValue") == 0L)
                        {</xsl:text>
					       <xsl:value-of select="sacl:expiration/sacl:javaCode"/><xsl:text>
                        }
                        else
                        {
                           java.util.Calendar cal = java.util.Calendar.getInstance(java.util.TimeZone.getTimeZone("GMT"));
					       cal.setTime(new java.util.Date(252981792000000L));
                           return cal;
                        }</xsl:text>

					</xsl:element>
				</xsl:when>	
				<xsl:otherwise>
					<xsl:element name="until">
						<xsl:text>java.util.Calendar cal = java.util.Calendar.getInstance(java.util.TimeZone.getTimeZone("GMT"));
						cal.setTime(new java.util.Date(BSMState_Input_.getLong("</xsl:text><xsl:value-of select="$timer"/><xsl:text>TimerValue")));
						return cal;</xsl:text>
					</xsl:element>
				</xsl:otherwise>
			</xsl:choose>

            <xsl:element name="sequence">

                <xsl:choose>
                    <xsl:when test="count(./sacl:guard) = 0">
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:call-template name="ExecuteJavaCode">
                            <xsl:with-param name="code">
                                <xsl:if test="./sacl:expiration">
                                    BSMState_Input_.setLong("<xsl:value-of select="./sacl:expiration/@name"/>TimerValue", 252981792000000L);
                                </xsl:if>
                                <xsl:if test="./sacl:duration">
                                    BSMState_Input_.setLong("<xsl:value-of select="./sacl:duration/@name"/>TimerValue", 252981792000000L);
                                </xsl:if>			
                            </xsl:with-param>
                        </xsl:call-template>
                    </xsl:otherwise>
                </xsl:choose>

                <xsl:call-template name="addStateTransitionCheckForTimers">
                    <xsl:with-param name="trans" select="."/>
                </xsl:call-template>

            </xsl:element>

		</xsl:element>
	</xsl:template>
	
	<xsl:template name="addAssignSetNxt">
		<xsl:param name="actTrans"/>
		
        <genutil:trace message="name=addAssignSetNxt active transition= " select="concat($actTrans/@name, concat(' source=', concat($actTrans/sacl:sourceState, concat(' target=', $actTrans/sacl:targetState))))"/>

        <xsl:call-template name="ExecuteJavaCode2">
            <xsl:with-param name="transitionName"><xsl:value-of select="$actTrans/@name"/></xsl:with-param>
            <xsl:with-param name="stateName"><xsl:value-of select="$actTrans/sacl:targetState"/></xsl:with-param>
            <xsl:with-param name="code">
                <xsl:if test="$actTrans/sacl:expiration">
                BSMState_Input_.setLong("<xsl:value-of select="$actTrans/sacl:expiration/@name"/>TimerValue", 252981792000000L);
                </xsl:if>
                <xsl:if test="$actTrans/sacl:duration">
                BSMState_Input_.setLong("<xsl:value-of select="$actTrans/sacl:duration/@name"/>TimerValue", 252981792000000L);
                </xsl:if>			
         BSMState_Input_.setString("NxtState", "<xsl:choose><xsl:when test="$actTrans/../../sacl:compositeStateMachine[./@name = $actTrans/sacl:targetState]"><xsl:value-of select="$actTrans/../../sacl:compositeStateMachine[@name = $actTrans/sacl:targetState]/sacl:initialState/@name"/></xsl:when>
                         <xsl:otherwise><xsl:value-of select="$actTrans/sacl:targetState"/></xsl:otherwise></xsl:choose>");
        BSMState_Input_.setString("NxtTrans", "<xsl:value-of select="$actTrans/@name"/>");

        <xsl:if test="$actTrans[sacl:sourceState=sacl:targetState][@internal='true']">
         BSMState_Input_.setBoolean("SkipEntry", true);
        </xsl:if>
            </xsl:with-param>
        </xsl:call-template>

	</xsl:template>	
	
	<!-- *** EXIT ACTIONS ************************************************* -->

	<!-- Add exit actions for simple states -->
	<xsl:template match="sacl:state" mode="exit">
		<xsl:variable name="state" select="@name"/>
		<xsl:if test="sacl:exit">
            <xsl:element name="case">
                <!-- Build case condition -->
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">
                        <xsl:text>return BSMState_Input_.getString("ActState").equals("</xsl:text>
                        <xsl:value-of select="$state"/>
                        <xsl:text>");</xsl:text>
                    </xsl:with-param>
                </xsl:call-template>
                <!-- Add structure -->
                <xsl:apply-templates select="sacl:exit" mode="invokeSimple"/>
            </xsl:element>
		</xsl:if>	
	</xsl:template>

	<!-- Add exit actions for composite states -->
	<xsl:template name="handleCompositeExitActions">
		<xsl:variable name="compStates" select="/*/*/sacl:compositeState"/>
        <xsl:for-each select="deploymentpkg:composite-exit-order($bsmxslhelper)/composite">
            <xsl:variable name="compStateName" select="@name"/>
            <genutil:trace message="handleCompositeExitActions::checking compStateName=" select="$compStateName"/>
            <xsl:for-each select="$compStates">
                <genutil:trace message="handleCompositeExitActions::inside the for-each for compStateName=" select="@name"/>
                <xsl:if test="@name = $compStateName">
                    <genutil:trace message="handleCompositeExitActions::processing compStateName=" select="@name"/>
                    <xsl:if test="./sacl:exit">
                        <genutil:trace message="handleCompositeExitActions::exit action exists for compStateName=" select="$compStateName"/>
                        <xsl:element name="switch">
                            <xsl:element name="case">
                                <!-- Build case condition -->
                                <xsl:call-template name="addCondition">
                                    <xsl:with-param name="cond">return (
                                    <xsl:choose>
                                        <xsl:when test="/*/*/sacl:transition[@internal='true']">
                                            <xsl:text>!BSMState_Input_.getBoolean("SkipEntry") &amp;&amp;</xsl:text>
                                        </xsl:when>
                                    </xsl:choose>
                                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.executeExitAction(BSMState_Input_, this,BSMState_Input_.getString("NxtTrans"),BSMState_Input_.getString("ActState"),BSMState_Input_.getString("NxtState"),"<xsl:value-of select="$compStateName"/>"));</xsl:with-param>
                                </xsl:call-template>
                                <!-- Add structure -->
                                <xsl:apply-templates select="sacl:exit" mode="invoke"/>
                            </xsl:element>
                        </xsl:element>
                    </xsl:if>	
                </xsl:if>
            </xsl:for-each>
        </xsl:for-each>
	</xsl:template>
	
	<!-- *** timer resets ************************************************* -->

	<xsl:template match="sacl:state" mode="timer">
		<xsl:variable name="state" select="@name"/>
        <xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:expiration">
               BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", 252981792000000L);
       </xsl:for-each>
        <xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:duration">
            <xsl:text> </xsl:text>
               BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", 252981792000000L);
        </xsl:for-each>
	</xsl:template>

	<xsl:template match="sacl:compositeState" mode="timer">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="timeout" select="../sacl:transition[sacl:sourceState = $state][sacl:duration|sacl:expiration]"/>
		<xsl:if test="$timeout">
            <xsl:element name="switch">
                <xsl:element name="case">
                    <!-- Build case condition -->
                    <xsl:call-template name="addCondition">
                        <xsl:with-param name="cond">return (
                            <xsl:choose>
                                <xsl:when test="/*/*/sacl:transition[@internal='true']">
                                    <xsl:text>!BSMState_Input_.getBoolean("SkipEntry") &amp;&amp;</xsl:text>
                                </xsl:when>
                            </xsl:choose> 
                               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.executeExitAction(BSMState_Input_, this,BSMState_Input_.getString("NxtTrans"),BSMState_Input_.getString("ActState"),BSMState_Input_.getString("NxtState"),"<xsl:value-of select="$state"/>"));</xsl:with-param>
                    </xsl:call-template>
                    <!-- Add structure -->
                    <xsl:apply-templates select="." mode="resetTimer"/>
                </xsl:element>
            </xsl:element>
		</xsl:if>	
	</xsl:template>

	<xsl:template match="sacl:compositeState" mode="resetTimer">
		<xsl:variable name="state" select="@name"/>
        <xsl:element name="invoke">
            <xsl:attribute name="name">
                <xsl:value-of select="@name"/><xsl:text>.resetTimer</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="partnerLink">null</xsl:attribute>
            <xsl:attribute name="portType">wpc:null</xsl:attribute>
            <xsl:attribute name="operation">null</xsl:attribute>
            <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nondebugid')"/></xsl:attribute>
            <xsl:variable name="code">
                <xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:expiration">
                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.timerUnsetting(BSMState_Input_, this,"<xsl:value-of select="../@name"/>");
                BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", 252981792000000L);
                </xsl:for-each>
                <xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:duration">
                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.timerUnsetting(BSMState_Input_, this,"<xsl:value-of select="../@name"/>");
                BSMState_Input_.setLong("<xsl:value-of select="@name"/>TimerValue", 252981792000000L);
                </xsl:for-each>
            </xsl:variable>		
            <xsl:element name="wpc:script">
                <wpc:javaCode>
                    <xsl:value-of select="$code"/>
                </wpc:javaCode>
            </xsl:element>
        </xsl:element>
	</xsl:template>

	<!-- *** TRANSITION'S ACTIONS ***************************************** -->

	<xsl:template match="sacl:transition" mode="execute">
        <genutil:trace message="match=sacl:transition mode=execute transition name=" select="concat(@name, concat(' internal=', @internal))"/>
		<xsl:variable name="state" select="sacl:sourceState"/>
        
        <xsl:element name="case">
            <!-- Build case condition -->
            <xsl:call-template name="addCondition">
                <xsl:with-param name="cond">
                    <xsl:text>return BSMState_Input_.getString("NxtTrans").equals("</xsl:text>
                    <xsl:value-of select="@name"/>
                    <xsl:text>");</xsl:text>
                </xsl:with-param>
            </xsl:call-template>
            <!-- Add structure -->
            <xsl:choose>
                <xsl:when test="sacl:operation">
                        <xsl:variable name="event">
                            <xsl:value-of select="./sacl:operation/@portType"/>
                            <xsl:text>.</xsl:text>
                            <xsl:value-of select="./sacl:operation/@name"/>
                        </xsl:variable>
                        <xsl:choose>
                            <xsl:when test="deploymentpkg:is-two-way($bsmxslhelper,$event)">
                                <xsl:element name="sequence">
                                    <xsl:if test="sacl:action">
                                        <xsl:apply-templates select="sacl:action" mode="invoke"/>
                                    </xsl:if>
                                    <xsl:apply-templates select="sacl:operation" mode="replyTo"/>
                                </xsl:element>
                            </xsl:when>
                            <xsl:when test="deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
                                <xsl:if test="sacl:action">
                                    <xsl:apply-templates select="sacl:action" mode="invoke"/>
                                </xsl:if>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:if test="sacl:action">
                                    <xsl:apply-templates select="sacl:action" mode="invokeSimple"/>
                                </xsl:if>
                            </xsl:otherwise>
                        </xsl:choose>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates select="sacl:action" mode="invokeSimple"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:element>
	</xsl:template>

	<!-- *** ACTION INVOCATION ******************************************** -->

	<xsl:template match="sacl:operation" mode="replyTo">
		<xsl:param name="type"/>
		<xsl:param name="FaultMessage">SACL_RuntimeFault[<xsl:value-of select="deploymentpkg:getMessage($bsmxslhelper,'DeployCommand.UnknownFailure')"/>]</xsl:param>
		<genutil:trace message="match=sacl:operation mode=replyTo " select="concat('name=', concat(@name, concat(' type=', concat($type, concat(' FaultMessage=', $FaultMessage)))))"/>
		
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>

        <xsl:choose>

            <xsl:when test="contains($type,'Fault') and deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
                <genutil:trace message="match=sacl:operation mode=replyTo: operation hasBSMFault" select="."/>

                <xsl:element name="assign">
                    <xsl:element name="copy">
                        <xsl:element name="from"><xsl:value-of select="$FaultMessage"/></xsl:element>
                        <xsl:element name="to">
                            <xsl:attribute name="variable">BSM__Output__Fault</xsl:attribute>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>

                <xsl:element name="reply">
                    <xsl:attribute name="partnerLink">
                        <xsl:value-of select="substring-after(@portType,':')"/>
                    </xsl:attribute>
                    <xsl:attribute name="portType"><xsl:value-of select="@portType"/></xsl:attribute>
                    <xsl:attribute name="operation"><xsl:value-of select="@name"/></xsl:attribute>
                    <xsl:attribute name="faultName"><xsl:value-of select="deploymentpkg:getBSMFaultQName($bsmxslhelper,$event)"/></xsl:attribute>
                    <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                        <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                           <xsl:attribute name="name"><xsl:value-of select="deploymentpkg:getBSMFaultPartName($bsmxslhelper,$event)"/></xsl:attribute>
                           <xsl:attribute name="variable">BSM__Output__Fault</xsl:attribute>
                       </xsl:element>
                    </xsl:element>
                </xsl:element>

            </xsl:when>

            <xsl:when test="deploymentpkg:is-two-way($bsmxslhelper,$event)">
                <genutil:trace message="match=sacl:operation mode=replyTo: operation isTwoWay" select="."/>
                <xsl:call-template name="ExecuteJavaCode">
                <xsl:with-param name="code">
                 /**
                  *@bpe.readOnlyVariables names="BSMState_Input_"
                  */
                 com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.sendingResponse(BSMState_Input_, this,
                          "<xsl:value-of select="substring-after(@portType,':')"/>","<xsl:value-of select="@name"/>",new Object[]{
                              <xsl:for-each select="deploymentpkg:output-parts($bsmxslhelper,$event, 'no')/part">
                                  <xsl:value-of select="@operation"/><xsl:text>_Output_</xsl:text><xsl:value-of select="@name"/>
                                  <xsl:if test="position()&lt;last()">
                                      <xsl:text>,</xsl:text>
                                  </xsl:if>
                              </xsl:for-each>});</xsl:with-param>
                          </xsl:call-template>
                        
                <xsl:element name="reply">
                    <xsl:attribute name="partnerLink">
                        <xsl:value-of select="substring-after(@portType,':')"/>
                    </xsl:attribute>
                    <xsl:attribute name="portType"><xsl:value-of select="@portType"/></xsl:attribute>
                    <xsl:attribute name="operation"><xsl:value-of select="@name"/></xsl:attribute>
                    <xsl:choose>
                        <xsl:when test="contains($type,'Fault')">
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:choose>
                                <xsl:when test="./sacl:correlations/sacl:correlation[@initiate='response']">
                                    <xsl:element name="correlations">
                                        <xsl:element name="correlation">
                                            <xsl:attribute name="initiate">yes</xsl:attribute>
                                            <xsl:attribute name="set">
                                                <xsl:value-of select="/*/sacl:correlationSet/@name"/>
                                            </xsl:attribute>
                                        </xsl:element>
                                    </xsl:element>
                                </xsl:when>
                            </xsl:choose>
                        </xsl:otherwise>
                    </xsl:choose>
                    <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                        <xsl:apply-templates select="." mode="addWpcOutputParameters"/>
                    </xsl:element>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <genutil:trace message="match=sacl:operation mode=replyTo: operation not(isTwoWay) and not(hasBSMFault)" select="."/>
            </xsl:otherwise>
        </xsl:choose>
	</xsl:template>

	<!-- *** ACTION INVOCATION ******************************************** -->
			
	<xsl:template match="sacl:operation" mode="addWpcInputParamters">
		<xsl:param name="variable"/>
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>

		<xsl:for-each select="deploymentpkg:input-parts($bsmxslhelper,$event, 'no')/part">
		<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			<xsl:attribute name="variable"><xsl:value-of select="@operation"/><xsl:text>_Input_</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
		</xsl:element>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template match="sacl:operation" mode="addWpcOutputParameters">		
		<xsl:param name="variable"/>	
		<genutil:trace message="xsl:template match=sacl:operation mode=addWpcOutputParameters" select="."/>		
		
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>

		<xsl:for-each select="deploymentpkg:output-parts($bsmxslhelper,$event, 'no')/part">
		<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			<xsl:attribute name="variable"><xsl:value-of select="@operation"/><xsl:text>_Output_</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
		</xsl:element>
		</xsl:for-each>
	</xsl:template>
			
	<xsl:template name="ExecuteJavaCode">
		<xsl:param name="code"/>
        <xsl:param name="elementName"/>

		<xsl:element name="invoke">
            <xsl:if test="$elementName">
                <xsl:attribute name="name"><xsl:value-of select="$elementName"/></xsl:attribute>
            </xsl:if>
            <xsl:attribute name="partnerLink">null</xsl:attribute>
			<xsl:attribute name="portType">wpc:null</xsl:attribute>
			<xsl:attribute name="operation">null</xsl:attribute>
			<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'theidkey')"/></xsl:attribute>
			<xsl:element name="wpc:script">
				<wpc:javaCode>
					<xsl:value-of select="$code"/>
				</wpc:javaCode>
			</xsl:element>
		</xsl:element>		
	</xsl:template>
			
	<xsl:template name="ExecuteJavaCode2">
		<xsl:param name="code"/>
        <xsl:param name="elementName"/>
        <xsl:param name="transitionName"/>
        <xsl:param name="stateName"/>

        <genutil:trace message="ExecuteJavaCode2 entry" select="$transitionName"/>

		<xsl:element name="invoke">
            <xsl:if test="$elementName">
                <xsl:attribute name="name"><xsl:value-of select="$elementName"/></xsl:attribute>
            </xsl:if>
            <xsl:attribute name="partnerLink">null</xsl:attribute>
			<xsl:attribute name="portType">wpc:null</xsl:attribute>
			<xsl:attribute name="operation">null</xsl:attribute>
            <xsl:variable name="debugSourceId" select="$stateName"/>
            <xsl:attribute name="wpc:displayName">
                <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=START Tr=</xsl:text><xsl:value-of select="$transitionName"/>
            </xsl:attribute>
            <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
			<xsl:element name="wpc:script">
				<wpc:javaCode>
					<xsl:value-of select="$code"/>
				</wpc:javaCode>
			</xsl:element>
		</xsl:element>	

        <genutil:trace message="ExecuteJavaCode2 exit" select="$stateName"/>

	</xsl:template>
	
	<xsl:template match="sacl:exit" mode="invoke">
		<xsl:element name="scope">
            <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
			<xsl:element name="faultHandlers">
                <xsl:element name="catch">
                    <xsl:attribute name="faultName"><xsl:text>wpc:runtimeFailure</xsl:text></xsl:attribute>
                    <xsl:attribute name="faultVariable">JavaRuntimeFailureData</xsl:attribute>
                    <xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">artifacts:runtimeFailureType</xsl:attribute>
                    <xsl:call-template name="ExecuteJavaCode">
                        <xsl:with-param name="code">/**
                                  *@bpe.readOnlyVariables names="BSMState_Input_"
                                  */
                                   com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.actionFailure(BSMState_Input_, this,"<xsl:value-of select="@name"/>",JavaRuntimeFailureData);</xsl:with-param>
                    </xsl:call-template>
                </xsl:element>
                <xsl:element name="catch">
                    <xsl:attribute name="faultVariable">AnyTypeData</xsl:attribute>
                    <xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">xsd:anyType</xsl:attribute>
                    <xsl:call-template name="ExecuteJavaCode">
                        <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                            String faultName = ex.getFaultName();

                            Hashtable faultDataHT = new Hashtable();
                            faultDataHT.put("faultName", faultName);
                            faultDataHT.put("faultData", AnyTypeData);

                             /**
                              *@bpe.readOnlyVariables names="BSMState_Input_"
                              */
                                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.actionFailure(BSMState_Input_, this,"<xsl:value-of select="@name"/>",faultDataHT);</xsl:with-param>
                    </xsl:call-template>
                </xsl:element>
				<xsl:element name="catchAll">
                    <xsl:call-template name="ExecuteJavaCode">
                        <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                            String faultName = ex.getFaultName();
                                     /**
                                      *@bpe.readOnlyVariables names="BSMState_Input_"
                                      */
                               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.actionFailure(BSMState_Input_, this,"<xsl:value-of select="@name"/>",faultName);</xsl:with-param>
                    </xsl:call-template>
				</xsl:element>		
			</xsl:element>
			<xsl:element name="sequence">
				<xsl:call-template name="ActionPreInvoke"/>
				<xsl:element name="invoke">
					<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
					<xsl:if test="sacl:javaCode">
						<xsl:variable name="debugSourceId" select="../@name"/>
						<xsl:attribute name="wpc:displayName">
						<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=ExitAction</xsl:text></xsl:attribute>
						<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
						<xsl:attribute name="partnerLink">null</xsl:attribute>
						<xsl:attribute name="portType">wpc:null</xsl:attribute>
						<xsl:attribute name="operation">null</xsl:attribute>
						<xsl:element name="wpc:script">
							<wpc:javaCode>
								<xsl:value-of select="sacl:javaCode"/>
							</wpc:javaCode>
						</xsl:element>
					</xsl:if>
					<xsl:for-each select="sacl:invoke">
							<xsl:variable name="debugSourceId" select="../../@name"/>
                            <xsl:attribute name="wpc:transactionalBehavior">
                                    <xsl:text>participates</xsl:text>
                            </xsl:attribute>
							<xsl:attribute name="wpc:displayName">
							<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=ExitAction</xsl:text></xsl:attribute>
							<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
							<xsl:attribute name="partnerLink">
								<xsl:value-of select="@reference"/>
							</xsl:attribute>
							<xsl:attribute name="portType">
								<xsl:value-of select="deploymentpkg:resolve-port-type($bsmxslhelper,.)"/>
							</xsl:attribute>
							<xsl:attribute name="operation"><xsl:value-of select="@operation"/></xsl:attribute>
							<genutil:trace message="Adding invoke of external operation" select="."/>
							<xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
								<xsl:for-each select="sacl:input">
									<xsl:for-each select="sacl:parameter">
										<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
											<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
											<xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
										</xsl:element>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:element>
							<xsl:if test="deploymentpkg:is-two-way($bsmxslhelper,@reference,@operation)">
								<xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
									<xsl:for-each select="sacl:output">
										<xsl:for-each select="sacl:parameter">
											<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
												<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
												<xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
											</xsl:element>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:element>			
							</xsl:if>
					</xsl:for-each>
				</xsl:element>
				<xsl:call-template name="ActionPostInvoke"/>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	
	<xsl:template match="sacl:action" mode="invoke">
		<xsl:variable name="operation" select="../sacl:operation"/>
		<xsl:variable name="event">
			<xsl:value-of select="../sacl:operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="../sacl:operation/@name"/>
		</xsl:variable>
		<xsl:element name="scope">
            <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>

			<xsl:element name="faultHandlers">

                <xsl:element name="catch">
                    <xsl:attribute name="faultName"><xsl:text>wpc:runtimeFailure</xsl:text></xsl:attribute>
                    <xsl:attribute name="faultVariable">JavaRuntimeFailureData</xsl:attribute>
                    <xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">artifacts:runtimeFailureType</xsl:attribute>
                    <xsl:element name="sequence">
                        <xsl:choose>
                            <xsl:when test="deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
                                <xsl:call-template name="ExecuteJavaCode">
                                      <xsl:with-param name="code">BSMState_Input_.setBoolean("InTransition", false);

                                          BSM__Output__Fault = com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, false, JavaRuntimeFailureData);</xsl:with-param>
                                 </xsl:call-template>
                                <xsl:element name="reply">
                                    <xsl:attribute name="partnerLink"><xsl:value-of select="substring-after(../sacl:operation/@portType,':')"/></xsl:attribute>
                                    <xsl:attribute name="portType"><xsl:value-of select="../sacl:operation/@portType"/></xsl:attribute>
                                    <xsl:attribute name="operation"><xsl:value-of select="../sacl:operation/@name"/></xsl:attribute>
                                    <xsl:attribute name="faultName"><xsl:value-of select="deploymentpkg:getBSMFaultQName($bsmxslhelper,$event)"/></xsl:attribute>
                                    <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                        <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                           <xsl:attribute name="name"><xsl:value-of select="deploymentpkg:getBSMFaultPartName($bsmxslhelper,$event)"/></xsl:attribute>
                                           <xsl:attribute name="variable">BSM__Output__Fault</xsl:attribute>
                                       </xsl:element>
                                    </xsl:element>
                                </xsl:element>
                                <xsl:element name="throw">
                                    <xsl:attribute name="faultName">SACL_Fault</xsl:attribute>
                                </xsl:element>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:apply-templates select="../sacl:operation" mode="replyTo">
                                    <xsl:with-param name="type" select="'Fault'"/>
                                </xsl:apply-templates>
                                <xsl:call-template name="ExecuteJavaCode">
                                      <xsl:with-param name="code">/**
                                          *@bpe.readOnlyVariables names="BSMState_Input_"
                                          */
                                          com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, true, JavaRuntimeFailureData);
                                        
                                          QName faultQName = new QName("http://www.ibm.com/xmlns/prod/websphere/wbi/sacl/6.0.0", "SACL_Fault", "sacl");  
                                          raiseFault(faultQName);</xsl:with-param>
                                 </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:element>
                </xsl:element>

                <xsl:element name="catch">
                    <xsl:attribute name="faultVariable">AnyTypeData</xsl:attribute>
                    <xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">xsd:anyType</xsl:attribute>
                    <xsl:element name="sequence">
                        <xsl:choose>
                            <xsl:when test="deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
                                <xsl:call-template name="ExecuteJavaCode">
                                    <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                                        String faultName = ex.getFaultName();

                                        Hashtable faultDataHT = new Hashtable();
                                        faultDataHT.put("faultName", faultName);
                                        faultDataHT.put("faultData", AnyTypeData);

                                         BSMState_Input_.setBoolean("InTransition", false);

                                         BSM__Output__Fault =  com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, false, faultDataHT);</xsl:with-param>
                                 </xsl:call-template>
                                <xsl:element name="reply">
                                    <xsl:attribute name="partnerLink"><xsl:value-of select="substring-after(../sacl:operation/@portType,':')"/></xsl:attribute>
                                    <xsl:attribute name="portType"><xsl:value-of select="../sacl:operation/@portType"/></xsl:attribute>
                                    <xsl:attribute name="operation"><xsl:value-of select="../sacl:operation/@name"/></xsl:attribute>
                                    <xsl:attribute name="faultName"><xsl:value-of select="deploymentpkg:getBSMFaultQName($bsmxslhelper,$event)"/></xsl:attribute>
                                    <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                        <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                           <xsl:attribute name="name"><xsl:value-of select="deploymentpkg:getBSMFaultPartName($bsmxslhelper,$event)"/></xsl:attribute>
                                           <xsl:attribute name="variable">BSM__Output__Fault</xsl:attribute>
                                       </xsl:element>
                                    </xsl:element>
                                </xsl:element>
                                <xsl:element name="throw">
                                    <xsl:attribute name="faultName">SACL_Fault</xsl:attribute>
                                </xsl:element>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:apply-templates select="../sacl:operation" mode="replyTo">
                                    <xsl:with-param name="type" select="'Fault'"/>
                                </xsl:apply-templates>
                                <xsl:call-template name="ExecuteJavaCode">
                                    <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                                        String faultName = ex.getFaultName();

                                        Hashtable faultDataHT = new Hashtable();
                                        faultDataHT.put("faultName", faultName);
                                        faultDataHT.put("faultData", AnyTypeData);
                                         /**
                                          *@bpe.readOnlyVariables names="BSMState_Input_"
                                          */
                                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, true, faultDataHT);

                                        QName faultQName = new QName("http://www.ibm.com/xmlns/prod/websphere/wbi/sacl/6.0.0", "SACL_Fault", "sacl");  
                                        raiseFault(faultQName);</xsl:with-param>
                                 </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:element>
                </xsl:element>

				<xsl:element name="catchAll">
					<xsl:element name="sequence">
                        <xsl:choose>
                            <xsl:when test="deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
                                <xsl:call-template name="ExecuteJavaCode">
                                    <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                                        String faultName = ex.getFaultName();

                                          BSMState_Input_.setBoolean("InTransition", false);
                                          BSM__Output__Fault =  com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, false, faultName);</xsl:with-param>
                                 </xsl:call-template>
                                <xsl:element name="reply">
                                    <xsl:attribute name="partnerLink"><xsl:value-of select="substring-after(../sacl:operation/@portType,':')"/></xsl:attribute>
                                    <xsl:attribute name="portType"><xsl:value-of select="../sacl:operation/@portType"/></xsl:attribute>
                                    <xsl:attribute name="operation"><xsl:value-of select="../sacl:operation/@name"/></xsl:attribute>
                                    <xsl:attribute name="faultName"><xsl:value-of select="deploymentpkg:getBSMFaultQName($bsmxslhelper,$event)"/></xsl:attribute>
                                    <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                        <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                           <xsl:attribute name="name"><xsl:value-of select="deploymentpkg:getBSMFaultPartName($bsmxslhelper,$event)"/></xsl:attribute>
                                           <xsl:attribute name="variable">BSM__Output__Fault</xsl:attribute>
                                       </xsl:element>
                                    </xsl:element>
                                </xsl:element>
                                <xsl:element name="throw">
                                    <xsl:attribute name="faultName">SACL_Fault</xsl:attribute>
                                </xsl:element>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:apply-templates select="../sacl:operation" mode="replyTo">
                                    <xsl:with-param name="type" select="'Fault'"/>
                                </xsl:apply-templates>
                                <xsl:call-template name="ExecuteJavaCode">
                                    <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                                        String faultName = ex.getFaultName();
                                        /**
                                          *@bpe.readOnlyVariables names="BSMState_Input_"
                                          */
                                       com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionFailure(BSMState_Input_, this, true, faultName);
                                        
                                       QName faultQName = new QName("http://www.ibm.com/xmlns/prod/websphere/wbi/sacl/6.0.0", "SACL_Fault", "sacl");  
                                       raiseFault(faultQName);</xsl:with-param>
                                 </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
					</xsl:element>								
				</xsl:element>	  

			</xsl:element>

            <xsl:apply-templates select="." mode="invokeSimple"/>
		</xsl:element>
	</xsl:template>

<xsl:template match="sacl:entry | sacl:exit | sacl:action" mode="invokeSimple">
    <xsl:variable name="nodeType">
        <xsl:choose>
            <xsl:when test="local-name() = 'entry'">
                <xsl:value-of select="'EntryAction'"/>
            </xsl:when>
            <xsl:when test="local-name() = 'exit'">
                <xsl:value-of select="'ExitAction'"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="'Action'"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:variable>
    <xsl:element name="invoke">
        <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
        <xsl:if test="sacl:javaCode">
            <xsl:variable name="debugSourceId" select="../@name"/>
            <xsl:attribute name="wpc:displayName">
            <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=</xsl:text><xsl:value-of select="$nodeType"/></xsl:attribute>
            <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
            <xsl:attribute name="partnerLink">null</xsl:attribute>
            <xsl:attribute name="portType">wpc:null</xsl:attribute>
            <xsl:attribute name="operation">null</xsl:attribute>
            <xsl:element name="wpc:script">
                <wpc:javaCode>
                    <xsl:value-of select="sacl:javaCode"/>
                </wpc:javaCode>
            </xsl:element>
        </xsl:if>
        <xsl:for-each select="sacl:invoke">
                <xsl:variable name="debugSourceId" select="../../@name"/>
                <xsl:attribute name="wpc:transactionalBehavior">
                        <xsl:text>participates</xsl:text>
                </xsl:attribute>
                <xsl:attribute name="wpc:displayName">
                <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=</xsl:text><xsl:value-of select="$nodeType"/></xsl:attribute>
                <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
                <xsl:attribute name="partnerLink">
                    <xsl:value-of select="@reference"/>
                </xsl:attribute>
                <xsl:attribute name="portType">
                    <xsl:value-of select="deploymentpkg:resolve-port-type($bsmxslhelper,.)"/>
                </xsl:attribute>
                <xsl:attribute name="operation"><xsl:value-of select="@operation"/></xsl:attribute>
                <genutil:trace message="Adding invoke of external operation" select="."/>
                <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                    <xsl:for-each select="sacl:input">
                        <xsl:for-each select="sacl:parameter">
                            <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                                <xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
                            </xsl:element>
                        </xsl:for-each>
                    </xsl:for-each>
                </xsl:element>
                <xsl:if test="deploymentpkg:is-two-way($bsmxslhelper,@reference,@operation)">
                    <xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                        <xsl:for-each select="sacl:output">
                            <xsl:for-each select="sacl:parameter">
                                <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                    <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                                    <xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
                                </xsl:element>
                            </xsl:for-each>
                        </xsl:for-each>
                    </xsl:element>			
                </xsl:if>
        </xsl:for-each>
    </xsl:element>
</xsl:template>
	
<xsl:template name="ActionPreInvoke">
    <xsl:call-template name="ExecuteJavaCode">
        <xsl:with-param name="code">
              /**
               *@bpe.readOnlyVariables names="BSMState_Input_"
               */
              com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.actionPreinvoke(BSMState_Input_, this,"<xsl:value-of select="@name"/>");</xsl:with-param>
    </xsl:call-template>
</xsl:template>

<xsl:template name="ActionPostInvoke">
    <xsl:call-template name="ExecuteJavaCode">
        <xsl:with-param name="code">
               /**
                *@bpe.readOnlyVariables names="BSMState_Input_"
                */
               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.actionPostinvoke(BSMState_Input_, this,"<xsl:value-of select="@name"/>");</xsl:with-param>
    </xsl:call-template>
</xsl:template>

<xsl:template name="EntryActionPreInvoke">
    <xsl:call-template name="ExecuteJavaCode">
        <xsl:with-param name="code">
            <xsl:choose>
                <xsl:when test="/*/*/*/sacl:entry">
                    BSMState_Input_.setBoolean("InEntry", true);
                </xsl:when>
                <xsl:otherwise>
                      /**
                       *@bpe.readOnlyVariables names="BSMState_Input_"
                       */
                </xsl:otherwise>
            </xsl:choose>
               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.entryActionPreinvoke(BSMState_Input_, this);</xsl:with-param>
    </xsl:call-template>
</xsl:template>

<xsl:template name="EntryActionPostInvoke">
    <xsl:call-template name="ExecuteJavaCode">
        <xsl:with-param name="code">
               /**
                *@bpe.readOnlyVariables names="BSMState_Input_"
                */
                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.entryActionPostinvoke(BSMState_Input_, this);</xsl:with-param>
    </xsl:call-template>
</xsl:template>

<xsl:template name="TransitionActionPreInvoke">
    <xsl:call-template name="ExecuteJavaCode">
        <xsl:with-param name="code">
            <xsl:if test="/*/*/*/sacl:exit">BSMState_Input_.setBoolean("InExit", false);
            </xsl:if>
                BSMState_Input_.setBoolean("InTransition", true);
                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionPreinvoke(BSMState_Input_, this);</xsl:with-param>
    </xsl:call-template>
</xsl:template>

<xsl:template name="TransitionActionPostInvoke">
    <xsl:call-template name="ExecuteJavaCode">
        <xsl:with-param name="code">
                      /**
                       *@bpe.readOnlyVariables names="BSMState_Input_"
                       */
                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionActionPostinvoke(BSMState_Input_, this);</xsl:with-param>
    </xsl:call-template>
</xsl:template>

	<xsl:template name="addStateTransitionCheck">
		<!-- the node list of guards -->
		<xsl:param name="trans"/>

        <genutil:trace message="addStateTransitionCheck: no. of transition=" select="count($trans)"/>
		
		<xsl:variable name="transition" select="$trans[position()=1]"/>	 

		<xsl:variable name="stateName">
            <xsl:value-of select="$transition/sacl:sourceState"/>
		</xsl:variable>
		
		<xsl:choose>
		<!-- unguarded transition -->
			<xsl:when test="count($transition/sacl:guard) = 0">
                <xsl:call-template name="addAssignSetNxt">
                    <xsl:with-param name="actTrans" select="$transition"/>
                </xsl:call-template>				
			</xsl:when>

			<xsl:otherwise>
                <!-- the transition that the first guard in the list belongs to -->
                <xsl:element name="sequence">

                    <xsl:call-template name="addNextGuardCheck">
                        <xsl:with-param name="trans" select="$trans"/>
                        <xsl:with-param name="pos" select="'1'"/>
                    </xsl:call-template> 

                    <xsl:if test="count($trans) &gt; 1">
                        <xsl:call-template name="addNextGuardSwitch">
                            <xsl:with-param name="trans" select="$trans"/>
                            <xsl:with-param name="pos" select="'2'"/>
                        </xsl:call-template> 
                    </xsl:if>

                </xsl:element>			
			</xsl:otherwise>

		</xsl:choose>
	</xsl:template>

	<xsl:template name="addStateTransitionCheckForAutos">
		<!-- the node list of guards -->
		<xsl:param name="trans"/>

        <genutil:trace message="addStateTransitionCheckForAutos: no. of transition=" select="count($trans)"/>
		
		<xsl:variable name="transition" select="$trans[position()=1]"/>	 

		<xsl:variable name="stateName">
            <xsl:value-of select="$transition/sacl:sourceState"/>
		</xsl:variable>
		
		<xsl:choose>
		<!-- unguarded transition: do not handle here.  they are handled else where -->
			<xsl:when test="count($transition/sacl:guard) = 0">
			</xsl:when>

			<xsl:otherwise>
                <!-- the transition that the first guard in the list belongs to -->
                <xsl:element name="sequence">

                    <xsl:call-template name="addNextGuardSwitchForAutos">
                        <xsl:with-param name="trans" select="$trans"/>
                        <xsl:with-param name="pos" select="'1'"/>
                    </xsl:call-template> 

                    <xsl:choose>
                        <xsl:when test="/*/*/sacl:transition[sacl:sourceState=$stateName][not(sacl:automatic)]">
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:if test="deploymentpkg:is-deadlock-possible($bsmxslhelper,$stateName)">
                                <xsl:element name="switch">
                                    <xsl:element name="case">
                                        <xsl:call-template name="addCondition">
                                            <xsl:with-param name="cond"><xsl:text>return(GuardValue.booleanValue() == false);</xsl:text></xsl:with-param>
                                        </xsl:call-template>
                                        <xsl:element name="throw">
                                            <xsl:attribute name="name">
                                                <xsl:value-of select="$stateName"/><xsl:text>Deadlock</xsl:text>
                                            </xsl:attribute>
                                            <xsl:attribute name="faultName">SACL_Deadlock</xsl:attribute>
                                        </xsl:element> 
                                    </xsl:element>
                                </xsl:element>
                            </xsl:if>
                        </xsl:otherwise>
                    </xsl:choose>

                </xsl:element>			
			</xsl:otherwise>

		</xsl:choose>
	</xsl:template>

	<xsl:template name="addStateTransitionCheckForTimers">
		<!-- the node list of guards -->
		<xsl:param name="trans"/>

        <genutil:trace message="addStateTransitionCheckForTimers: no. of transition=" select="count($trans)"/>
		
		<xsl:variable name="transition" select="$trans[position()=1]"/>	 

		<xsl:variable name="stateName">
            <xsl:value-of select="$transition/sacl:sourceState"/>
		</xsl:variable>
		
		<xsl:choose>
		<!-- unguarded transition -->
			<xsl:when test="count($transition/sacl:guard) = 0">
                <xsl:call-template name="addAssignSetNxt">
                    <xsl:with-param name="actTrans" select="$transition"/>
                </xsl:call-template>				
			</xsl:when>

			<xsl:otherwise>

                <xsl:call-template name="addNextGuardCheckNoScope">
                    <xsl:with-param name="trans" select="$trans"/>
                    <xsl:with-param name="pos" select="'1'"/>
                </xsl:call-template> 

			</xsl:otherwise>

		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="addNextGuardSwitch">
		<xsl:param name="trans"/>
		<xsl:param name="pos"/>

        <genutil:trace message="addNextGuardSwitch: position=" select="$pos"/>
        <genutil:trace message="addNextGuardSwitch: no. of transition=" select="count($trans)"/>

        <xsl:element name="switch">
            <xsl:element name="case">
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond"><xsl:text>return(GuardValue.booleanValue() == false);</xsl:text></xsl:with-param>
                </xsl:call-template>
                <xsl:call-template name="addNextGuardCheck">
                    <xsl:with-param name="trans" select="$trans"/>
                    <xsl:with-param name="pos" select="$pos"/>
                </xsl:call-template>
            </xsl:element>
        </xsl:element>

        <xsl:if test="$pos &lt; count($trans)">
                <xsl:call-template name="addNextGuardSwitch">
                    <xsl:with-param name="trans" select="$trans"/>
                    <xsl:with-param name="pos" select="$pos + 1"/>
                </xsl:call-template>
        </xsl:if>

	</xsl:template>
	
	<xsl:template name="addNextGuardSwitchForAutos">
		<xsl:param name="trans"/>
		<xsl:param name="pos"/>

        <genutil:trace message="addNextGuardSwitchForAutos: position=" select="$pos"/>
        <genutil:trace message="addNextGuardSwitchForAutos: no. of transition=" select="count($trans)"/>

        <xsl:choose>
            <xsl:when test="$pos &lt; 2">
                <xsl:element name="switch">
                    <xsl:element name="case">
                        <xsl:call-template name="addCondition">
                            <xsl:with-param name="cond">
                                <xsl:text>return BSMState_Input_.getInt("GuardCnt") == </xsl:text><xsl:value-of select="$pos - 1"/><xsl:text>;</xsl:text>
                             </xsl:with-param>
                        </xsl:call-template>
                        <xsl:call-template name="addNextGuardCheckNoScope">
                            <xsl:with-param name="trans" select="$trans"/>
                            <xsl:with-param name="pos" select="$pos"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <xsl:element name="switch">
                    <xsl:element name="case">
                        <xsl:call-template name="addCondition">
                            <xsl:with-param name="cond">
                                <xsl:text>return BSMState_Input_.getInt("GuardCnt") == </xsl:text><xsl:value-of select="$pos - 1"/>
                                <xsl:text> &amp;&amp; GuardValue.booleanValue() == false;</xsl:text>
                             </xsl:with-param>
                        </xsl:call-template>
                        <xsl:call-template name="addNextGuardCheckNoScope">
                            <xsl:with-param name="trans" select="$trans"/>
                            <xsl:with-param name="pos" select="$pos"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:element>
            </xsl:otherwise>
        </xsl:choose>

        <xsl:if test="$pos &lt; count($trans)">
                <xsl:call-template name="addNextGuardSwitchForAutos">
                    <xsl:with-param name="trans" select="$trans"/>
                    <xsl:with-param name="pos" select="$pos + 1"/>
                </xsl:call-template>
        </xsl:if>

	</xsl:template>

	<xsl:template name="addNextGuardCheck">
		<!-- the node list of guards -->
		<xsl:param name="trans"/>
		<xsl:param name="pos"/>

        <genutil:trace message="addNextGuardCheck: position=" select="$pos"/>
        <genutil:trace message="addNextGuardCheck: no. of transition=" select="count($trans)"/>
		
		<xsl:variable name="transition" select="$trans[position()=$pos]"/>		
		
        <genutil:trace message="addNextGuardCheck: transition name =" select="$transition/@name"/>
		
        <xsl:element name="scope">
            <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>

            <xsl:element name="faultHandlers">

                <xsl:element name="catch">
                    <xsl:attribute name="faultName"><xsl:text>wpc:runtimeFailure</xsl:text></xsl:attribute>
                    <xsl:attribute name="faultVariable">JavaRuntimeFailureData</xsl:attribute>
                    <xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">artifacts:runtimeFailureType</xsl:attribute>
                    <xsl:call-template name="ExecuteJavaCode">
                        <xsl:with-param name="code">/**
                               *@bpe.readOnlyVariables names="BSMState_Input_"
                               */
                               com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",JavaRuntimeFailureData);
                        </xsl:with-param>
                    </xsl:call-template>
                </xsl:element>

                <xsl:element name="catch">
                    <xsl:attribute name="faultVariable">AnyTypeData</xsl:attribute>
                    <xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">xsd:anyType</xsl:attribute>
                    <xsl:call-template name="ExecuteJavaCode">
                        <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                            String faultName = ex.getFaultName();

                            Hashtable faultDataHT = new Hashtable();
                            faultDataHT.put("faultName", faultName);
                            faultDataHT.put("faultData", AnyTypeData);
                            /**
                             *@bpe.readOnlyVariables names="BSMState_Input_"
                             */
                             com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",faultDataHT);</xsl:with-param>
                    </xsl:call-template>
                </xsl:element>

                <xsl:element name="catchAll">
                    <xsl:call-template name="ExecuteJavaCode">
                        <xsl:with-param name="code">com.ibm.bpe.api.BpelException ex = getCurrentFaultAsException();
                            String faultName = ex.getFaultName();
                            /**
                             *@bpe.readOnlyVariables names="BSMState_Input_"
                             */
                             com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",faultName);</xsl:with-param>
                    </xsl:call-template>
                </xsl:element>

            </xsl:element>

            <xsl:element name="sequence">

                <xsl:call-template name="ExecuteJavaCode">
                    <xsl:with-param name="code">
                      /**
                       *@bpe.readOnlyVariables names="BSMState_Input_"
                       */
                                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPreinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>");</xsl:with-param>
                </xsl:call-template>  

                <xsl:choose>
                    <xsl:when test="$transition/sacl:guard/sacl:javaCode">
                        <xsl:choose>
                            <xsl:when test="$transition/sacl:guard/@invert = 'true'">
                                <xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
                                    <xsl:element name="switch">
                                        <xsl:variable name="debugSourceId" select="../../@name"/>
                                        <xsl:attribute name="wpc:displayName">
                                        <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Guard</xsl:text></xsl:attribute>
                                        <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
                                        <xsl:element name="case">
                                            <xsl:element name="condition">
                                                <xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
                                                <xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
                                                    <xsl:value-of select="."/>
                                                </xsl:for-each>
                                            </xsl:element>
                                            <xsl:call-template name="ExecuteJavaCode">
                                                <xsl:with-param name="code">
                                                         /**
                                                          *@bpe.readOnlyVariables names="BSMState_Input_"
                                                          */
                                                         com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",false);
                                                </xsl:with-param>
                                            </xsl:call-template> 
                                        </xsl:element>
                                        <xsl:element name="otherwise">
                                            <xsl:call-template name="ExecuteJavaCode2">
                                                <xsl:with-param name="transitionName"><xsl:value-of select="$transition/@name"/></xsl:with-param>
                                                <xsl:with-param name="stateName"><xsl:value-of select="$transition/sacl:targetState"/></xsl:with-param>
                                                <xsl:with-param name="code">
                                                    GuardValue = Boolean.TRUE;
                                                         com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>", true);
                                                    BSMState_Input_.setString("NxtState",  "<xsl:choose>
                                    <xsl:when test="$transition/../../sacl:compositeStateMachine[./@name = $transition/sacl:targetState]">
                                        <xsl:value-of select="$transition/../../sacl:compositeStateMachine[@name = $transition/sacl:targetState]/sacl:initialState/@name"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:value-of select="$transition/sacl:targetState"/>
                                    </xsl:otherwise>
                                </xsl:choose>");
                                                         BSMState_Input_.setString("NxtTrans", "<xsl:value-of select="$transition/@name"/>");
                                <xsl:if test="$transition[sacl:sourceState=sacl:targetState][@internal='true']">
                                                         BSMState_Input_.setBoolean("SkipEntry", true);
                                </xsl:if>
                                                </xsl:with-param>
                                            </xsl:call-template> 
                                        </xsl:element>
                                    </xsl:element>
                                </xsl:for-each>

                            </xsl:when>

                            <xsl:otherwise>
                                <xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
                                    <xsl:element name="switch">
                                        <xsl:variable name="debugSourceId" select="../../@name"/>
                                        <xsl:attribute name="wpc:displayName">
                                        <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Guard</xsl:text></xsl:attribute>
                                        <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
                                        <xsl:element name="case">
                                            <xsl:element name="condition">
                                                <xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
                                                <xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
                                                    <xsl:value-of select="."/>
                                                </xsl:for-each>
                                            </xsl:element>
                                            <xsl:call-template name="ExecuteJavaCode2">
                                                <xsl:with-param name="transitionName"><xsl:value-of select="$transition/@name"/></xsl:with-param>
                                                <xsl:with-param name="stateName"><xsl:value-of select="$transition/sacl:targetState"/></xsl:with-param>
                                                <xsl:with-param name="code">
                                                    GuardValue = Boolean.TRUE;
                                                         com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>", true);
                                                    BSMState_Input_.setString("NxtState", "<xsl:choose>
                                    <xsl:when test="$transition/../../sacl:compositeStateMachine[./@name = $transition/sacl:targetState]">
                                        <xsl:value-of select="$transition/../../sacl:compositeStateMachine[@name = $transition/sacl:targetState]/sacl:initialState/@name"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:value-of select="$transition/sacl:targetState"/>
                                    </xsl:otherwise>
                                </xsl:choose>");
                                                         BSMState_Input_.setString("NxtTrans", "<xsl:value-of select="$transition/@name"/>");
                                <xsl:if test="$transition[sacl:sourceState=sacl:targetState][@internal='true']">
                                                         BSMState_Input_.setBoolean("SkipEntry", true);
                                </xsl:if>
                                                </xsl:with-param>
                                            </xsl:call-template> 
                                        </xsl:element>
                                        <xsl:element name="otherwise">
                                            <xsl:call-template name="ExecuteJavaCode">
                                                <xsl:with-param name="code">
                      /**
                       *@bpe.readOnlyVariables names="BSMState_Input_"
                       */
                                                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",false);
                                                </xsl:with-param>
                                            </xsl:call-template> 
                                        </xsl:element>
                                    </xsl:element>
                                </xsl:for-each>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:for-each select="$transition/sacl:guard/sacl:invoke">
                            <xsl:element name="invoke">
                                <xsl:attribute name="name"><xsl:value-of select="$transition/sacl:guard/@name"/></xsl:attribute>
                                <xsl:variable name="debugSourceId" select="../../@name"/>
                                <xsl:attribute name="wpc:transactionalBehavior">
                                        <xsl:text>participates</xsl:text>
                                </xsl:attribute>
                                <xsl:attribute name="wpc:displayName">
                                <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Guard</xsl:text></xsl:attribute>
                                <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
                                <xsl:attribute name="partnerLink">
                                    <xsl:value-of select="@reference"/>
                                </xsl:attribute>
                                <xsl:attribute name="portType">
                                    <xsl:value-of select="deploymentpkg:resolve-port-type($bsmxslhelper,.)"/>
                                </xsl:attribute>
                                <xsl:attribute name="operation"><xsl:value-of select="@operation"/></xsl:attribute>
                                <genutil:trace message="Adding invoke of external operation" select="."/>
                                <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                    <xsl:for-each select="sacl:input">
                                        <xsl:for-each select="sacl:parameter">
                                            <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                                <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                                                <xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
                                            </xsl:element>
                                        </xsl:for-each>
                                    </xsl:for-each>
                                </xsl:element>
                                <xsl:if test="deploymentpkg:is-two-way($bsmxslhelper,@reference,@operation)">
                                    <xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                        <xsl:for-each select="sacl:output">
                                            <xsl:for-each select="sacl:parameter">
                                                <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                                    <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                                                    <xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
                                                </xsl:element>
                                            </xsl:for-each>
                                        </xsl:for-each>
                                    </xsl:element>			
                                </xsl:if>
                            </xsl:element>							
                        </xsl:for-each>

                        <xsl:call-template name="ExecuteJavaCode2">
                            <xsl:with-param name="transitionName"><xsl:value-of select="$transition/@name"/></xsl:with-param>
                            <xsl:with-param name="stateName"><xsl:value-of select="$transition/sacl:targetState"/></xsl:with-param>
                            <xsl:with-param name="code">
                                boolean guardValue_bool = GuardValue.booleanValue();
                                <xsl:if test="$transition/sacl:guard/@invert = 'true'">
                                    guardValue_bool = !guardValue_bool;
                                    GuardValue = new Boolean(guardValue_bool);
                                </xsl:if>
                                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>", guardValue_bool);
                                 if (guardValue_bool)
                                 {
                                     BSMState_Input_.setString("NxtState", "<xsl:choose>
                <xsl:when test="$transition/../../sacl:compositeStateMachine[./@name = $transition/sacl:targetState]">
                    <xsl:value-of select="$transition/../../sacl:compositeStateMachine[@name = $transition/sacl:targetState]/sacl:initialState/@name"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$transition/sacl:targetState"/>
                </xsl:otherwise>
            </xsl:choose>");
                                     BSMState_Input_.setString("NxtTrans", "<xsl:value-of select="$transition/@name"/>");
            <xsl:if test="$transition[sacl:sourceState=sacl:targetState][@internal='true']">
                                     BSMState_Input_.setBoolean("SkipEntry", true);
            </xsl:if>
                                 }
                            </xsl:with-param>
                        </xsl:call-template> 

                    </xsl:otherwise>
                </xsl:choose>

            </xsl:element>
        </xsl:element>	 

	</xsl:template>

	<xsl:template name="addNextGuardCheckNoScope">
		<!-- the node list of guards -->
		<xsl:param name="trans"/>
		<xsl:param name="pos"/>

        <genutil:trace message="addNextGuardCheckNoScope: position=" select="$pos"/>
        <genutil:trace message="addNextGuardCheckNoScope: no. of transition=" select="count($trans)"/>
		
		<xsl:variable name="transition" select="$trans[position()=$pos]"/>		
		
        <genutil:trace message="addNextGuardCheckNoScope: transition name =" select="$transition/@name"/>
            
        <xsl:element name="sequence">

            <xsl:call-template name="ExecuteJavaCode">
                <xsl:with-param name="code">
                    <xsl:choose>
                        <xsl:when test="$transition[sacl:automatic]">BSMState_Input_.setInt("GuardCnt", <xsl:value-of select="$pos"/>);</xsl:when>
                        <xsl:otherwise>BSMState_Input_.setInt("GuardCnt", -1);</xsl:otherwise>
                    </xsl:choose>
                            BSMState_Input_.setString("GuardName", "<xsl:value-of select="$transition/sacl:guard/@name"/>");
                                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPreinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>");</xsl:with-param>
            </xsl:call-template>  

            <xsl:choose>
                <xsl:when test="$transition/sacl:guard/sacl:javaCode">
                    <xsl:choose>
                        <xsl:when test="$transition/sacl:guard/@invert = 'true'">
                            <xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
                                <xsl:element name="switch">
                                    <xsl:variable name="debugSourceId" select="../../@name"/>
                                    <xsl:attribute name="wpc:displayName">
                                    <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Guard</xsl:text></xsl:attribute>
                                    <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
                                    <xsl:element name="case">
                                        <xsl:element name="condition">
                                            <xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
                                            <xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
                                                <xsl:value-of select="."/>
                                            </xsl:for-each>
                                        </xsl:element>
                                        <xsl:call-template name="ExecuteJavaCode">
                                            <xsl:with-param name="code">
                      /**
                       *@bpe.readOnlyVariables names="BSMState_Input_"
                       */
                                                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",false);
                                            </xsl:with-param>
                                        </xsl:call-template> 
                                    </xsl:element>
                                    <xsl:element name="otherwise">
                                        <xsl:call-template name="ExecuteJavaCode2">
                                            <xsl:with-param name="transitionName"><xsl:value-of select="$transition/@name"/></xsl:with-param>
                                            <xsl:with-param name="stateName"><xsl:value-of select="$transition/sacl:targetState"/></xsl:with-param>
                                            <xsl:with-param name="code">
                                                GuardValue = Boolean.TRUE;
                                                   com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",true);
                                                BSMState_Input_.setString("NxtState", "<xsl:choose>
                                <xsl:when test="$transition/../../sacl:compositeStateMachine[./@name = $transition/sacl:targetState]">
                                    <xsl:value-of select="$transition/../../sacl:compositeStateMachine[@name = $transition/sacl:targetState]/sacl:initialState/@name"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:value-of select="$transition/sacl:targetState"/>
                                </xsl:otherwise>
                            </xsl:choose>");
                                                     BSMState_Input_.setString("NxtTrans", "<xsl:value-of select="$transition/@name"/>");
                            <xsl:if test="$transition[sacl:sourceState=sacl:targetState][@internal='true']">
                                                     BSMState_Input_.setBoolean("SkipEntry", true);
                            </xsl:if>
                                            </xsl:with-param>
                                        </xsl:call-template> 
                                    </xsl:element>
                                </xsl:element>
                            </xsl:for-each>

                        </xsl:when>

                        <xsl:otherwise>
                            <xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
                                <xsl:element name="switch">
                                    <xsl:variable name="debugSourceId" select="../../@name"/>
                                    <xsl:attribute name="wpc:displayName">
                                    <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Guard</xsl:text></xsl:attribute>
                                    <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
                                    <xsl:element name="case">
                                        <xsl:element name="condition">
                                            <xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
                                            <xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
                                                <xsl:value-of select="."/>
                                            </xsl:for-each>
                                        </xsl:element>
                                        <xsl:call-template name="ExecuteJavaCode2">
                                            <xsl:with-param name="transitionName"><xsl:value-of select="$transition/@name"/></xsl:with-param>
                                            <xsl:with-param name="stateName"><xsl:value-of select="$transition/sacl:targetState"/></xsl:with-param>
                                            <xsl:with-param name="code">
                                                GuardValue = Boolean.TRUE;
                                                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>", true);
                                                   BSMState_Input_.setString("NxtState", "<xsl:choose>
                                <xsl:when test="$transition/../../sacl:compositeStateMachine[./@name = $transition/sacl:targetState]">
                                    <xsl:value-of select="$transition/../../sacl:compositeStateMachine[@name = $transition/sacl:targetState]/sacl:initialState/@name"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:value-of select="$transition/sacl:targetState"/>
                                </xsl:otherwise>
                            </xsl:choose>");
                                                     BSMState_Input_.setString("NxtTrans", "<xsl:value-of select="$transition/@name"/>");
                            <xsl:if test="$transition[sacl:sourceState=sacl:targetState][@internal='true']">
                                                     BSMState_Input_.setBoolean("SkipEntry", true);
                            </xsl:if>
                                            </xsl:with-param>
                                        </xsl:call-template> 
                                    </xsl:element>
                                    <xsl:element name="otherwise">
                                        <xsl:call-template name="ExecuteJavaCode">
                                            <xsl:with-param name="code">
                      /**
                       *@bpe.readOnlyVariables names="BSMState_Input_"
                       */
                                                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",false);
                                            </xsl:with-param>
                                        </xsl:call-template> 
                                    </xsl:element>
                                </xsl:element>
                            </xsl:for-each>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select="$transition/sacl:guard/sacl:invoke">
                        <xsl:element name="invoke">
                            <xsl:attribute name="name"><xsl:value-of select="$transition/sacl:guard/@name"/></xsl:attribute>
                            <xsl:variable name="debugSourceId" select="../../@name"/>
                            <xsl:attribute name="wpc:transactionalBehavior">
                                    <xsl:text>participates</xsl:text>
                            </xsl:attribute>
                            <xsl:attribute name="wpc:displayName">
                            <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Guard</xsl:text></xsl:attribute>
                            <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
                            <xsl:attribute name="partnerLink">
                                <xsl:value-of select="@reference"/>
                            </xsl:attribute>
                            <xsl:attribute name="portType">
                                <xsl:value-of select="deploymentpkg:resolve-port-type($bsmxslhelper,.)"/>
                            </xsl:attribute>
                            <xsl:attribute name="operation"><xsl:value-of select="@operation"/></xsl:attribute>
                            <genutil:trace message="Adding invoke of external operation" select="."/>
                            <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                <xsl:for-each select="sacl:input">
                                    <xsl:for-each select="sacl:parameter">
                                        <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                            <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                                            <xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
                                        </xsl:element>
                                    </xsl:for-each>
                                </xsl:for-each>
                            </xsl:element>
                            <xsl:if test="deploymentpkg:is-two-way($bsmxslhelper,@reference,@operation)">
                                <xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                    <xsl:for-each select="sacl:output">
                                        <xsl:for-each select="sacl:parameter">
                                            <xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                                                <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                                                <xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
                                            </xsl:element>
                                        </xsl:for-each>
                                    </xsl:for-each>
                                </xsl:element>			
                            </xsl:if>
                        </xsl:element>							
                    </xsl:for-each>

                    <xsl:call-template name="ExecuteJavaCode2">
                        <xsl:with-param name="transitionName"><xsl:value-of select="$transition/@name"/></xsl:with-param>
                        <xsl:with-param name="stateName"><xsl:value-of select="$transition/sacl:targetState"/></xsl:with-param>
                        <xsl:with-param name="code">
                                boolean guardValue_bool = GuardValue.booleanValue();
                            <xsl:if test="$transition/sacl:guard/@invert = 'true'">
                                    guardValue_bool = !guardValue_bool;
                                    GuardValue = new Boolean(guardValue_bool);
                            </xsl:if>
                                com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(BSMState_Input_, this,"<xsl:value-of select="$transition/sacl:guard/@name"/>", guardValue_bool);
                             if (guardValue_bool)
                             {
                                  BSMState_Input_.setString("NxtState", "<xsl:choose>
            <xsl:when test="$transition/../../sacl:compositeStateMachine[./@name = $transition/sacl:targetState]">
                <xsl:value-of select="$transition/../../sacl:compositeStateMachine[@name = $transition/sacl:targetState]/sacl:initialState/@name"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$transition/sacl:targetState"/>
            </xsl:otherwise>
        </xsl:choose>");
                                 BSMState_Input_.setString("NxtTrans", "<xsl:value-of select="$transition/@name"/>");
        <xsl:if test="$transition[sacl:sourceState=sacl:targetState][@internal='true']">
                                 BSMState_Input_.setBoolean("SkipEntry", true);
        </xsl:if>
                             }
                        </xsl:with-param>
                    </xsl:call-template> 

                </xsl:otherwise>
            </xsl:choose>
        </xsl:element>

	</xsl:template>

</xsl:stylesheet>
